/***********************************************************************
<t@C>	abort.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		A{[gݒ聕QƂ֐
***********************************************************************/

#ifndef _ABORT_H_INCLUDED
#define _ABORT_H_INCLUDED

#include <privenv.h>


/*======================================================================
		萔`
======================================================================*/

/* A{[gtOێĂϐ */
#define	PRIVENV_NAME_ABORT	0x41424F54	/* 'ABOT' h2equ */


/*======================================================================
		^`
======================================================================*/

typedef unsigned long ABORTFLAG;
typedef unsigned long ABORTMASK;	/* abort.h̃[U[ŗpӂ */
typedef	unsigned long ABORTCOND;	/* (ABORTFLAG & ABORTMASK)̉Z */


/*======================================================================
		A{[gtO̒`

  yABORTFLAG̍\z

  (MSB)
  bit31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
	|<------------- \ for PC-Card (H'0000) ----->|WP0|SD0|RM0|EJ0|
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
													 <--PC-Card#0-->

																(LSB)
  bit15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
	|<--------- \(H'00)--------->|BRK|FLB|BTC|LSW|AOF|OFF|\ |PBS|
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+

 ebit'1'̂ƂAYṽA{[gĂ
======================================================================*/

#define	ABORT_PCCARD_BATT_SHORT	0x00000001	/* bit 0:drsPCCardgps */

#define	ABORT_OFF				0x00000004	/* bit 2:u؁vL[ꂽ*/
#define	ABORT_AUTO_POWER_OFF	0x00000008	/* bit 3:auto power off*/
#define	ABORT_BATT_COVER_OPEN	0x00000020	/* bit 5:drWJ */
#define	ABORT_FATAL_LOW_BATT	0x00000040	/* bit 6:drcʂȂ */
#define	ABORT_BREAK				0x00000080	/* bit 7:ufvL[ꂽ*/

#define	ABORT_PCCARD0_EJECTBTN	0x00010000	/* bit16:EJECT{^ꂽ */
#define	ABORT_PCCARD0_REMOVED	0x00020000	/* bit17:J[h */
#define	ABORT_PCCARD0_SHUTDOWN	0x00040000	/* bit18:ׂ̂ߓd */
#define	ABORT_PCCARD0_WPCHANGED	0x00080000	/* bit19:WriteProtect삳ꂽ */


#define	ABORT_ALL				0xFFFFFFFF	/* Sv */
#define	ABORT_MAINUNIT_ALL		0x000000FF	/* { Sv */
#define	ABORT_PCCARD0_ALL		0x000F0000	/* PC-Card Socket#0 Sv */


/*----------------------------------
	A{[g莞Ɏgl
----------------------------------*/

#define	ABORT_NONE	0	/* A{[gv͖ */


/*======================================================================
		}N錾
======================================================================*/


/***********************************************************************
y֐z  void SetAbort( ABORTFLAG Flag )
y@  \z  A{[gtO𗧂Ă
yz  Flag	Ărbg
y߂lz  Ȃ
***********************************************************************/

#define SetAbort(Flag)		SetBitPrivEnv(PRIVENV_NAME_ABORT,Flag)


/***********************************************************************
y֐z  void ClearAbort( ABORTFLAG Flag )
y@  \z  A{[gtO
yz  Flag	'0'ɂrbg
y߂lz  Ȃ
***********************************************************************/

#define	ClearAbort(Flag)	ClearBitPrivEnv(PRIVENV_NAME_ABORT,Flag)


/***********************************************************************
y֐z  ABORTFLAG LookAbort( void )
y@  \z  ݂̃A{[gtO
yz  Ȃ
y߂lz  ݂̃A{[gtO
***********************************************************************/

#define LookAbort()			((ABORTFLAG)ReadValuePrivEnv(PRIVENV_NAME_ABORT))


/***********************************************************************
y֐z  ABORTFLAG *GetAbortFlagAdr( void )
y@  \z  A{[gtOi[ĂAhX𓾂
yz  Ȃ
y߂lz  A{[gtÕAhXiAhXԓj
***********************************************************************/

#define	GetAbortFlagAdr()	((ABORTFLAG*)GetAdrPrivEnv(PRIVENV_NAME_ABORT))



/*
   ijZbgɎsꍇ

	{
	ABORTFLAG	CurrentAbort;

	CurrentAbort = LookAbort();
	// ŁACurrentAbort == ABORT_NONE(0)
	// SZbgAA{[ǵuvԂɂȂĂ

	SetAbort( ABORT_FATAL_LOW_BATT );
	CurrentAbort = LookAbort();
	// ŁACurrentAbort == ABORT_FATAL_LOW_BATT

	SetAbort( ABORT_BREAK );
	CurrentAbort = LookAbort();
	// ŁACurrentAbort == ABORT_FATAL_LOW_BATT+ABORT_BREAK

	ClearAbort( ABORT_FATAL_LOW_BATT );
	CurrentAbort = LookAbort();
	// ŁACurrentAbort == ABORT_BREAK
	}
*/

#endif /* _ABORT_H_INCLUDED */
