/***********************************************************************
<t@C>	cardsvc.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		J[hT[rX̒`
***********************************************************************/


#ifndef _CARDSVC_H_INCLUDED
#define _CARDSVC_H_INCLUDED

#include <sharpgen.h>
#include <cistuple.h>

#define	DUP_DEF	0	/* d`h */

#ifndef	UBYTE		/* xtaltypes.hƂԂ邽 */
typedef	unsigned char	UBYTE;
#endif
#ifndef	UWORD
typedef	unsigned short	UWORD;
#endif

#ifndef	NULL
#define	NULL	((void*)0)
#endif


typedef	void*	ADDRESS;

/***********************************************************************
			J[hT[rX  R[obN:CxgR[h
***********************************************************************/

typedef enum CS_EVENTCODE {
	BATTERY_DEAD			= 0x01,
	BATTERY_LOW				= 0x02,
	CARD_LOCK				= 0x03,
	CARD_READY				= 0x04,
	CARD_REMOVAL			= 0x05,
	CARD_UNLOCK				= 0x06,
	EJECTION_COMPLETE		= 0x07,
	EJECTION_REQUEST		= 0x08,
	INSERTION_COMPLETE		= 0x09,
	INSERTION_REQUEST		= 0x0a,
	PM_RESUME				= 0x0b,
	PM_SUSPEND				= 0x0c,
	EXCLUSIVE_COMPLETE		= 0x0d,
	EXCLUSIVE_REQUEST		= 0x0e,
	RESET_PHYSICAL			= 0x0f,

	RESET_REQUEST			= 0x10,
	CARD_RESET				= 0x11,
	MTD_REQUEST				= 0x12,
	/* 0x13 */
	CLIENT_INFO				= 0x14,
	TIMER_EXPIRED			= 0x15,
	SS_UPDATED				= 0x16,
	WRITE_PROTECT			= 0x17,
	REQUEST_ATTENTION		= 0x18,

	CARD_INSERTION			= 0x40,

	RESET_COMPLETE			= 0x80,
	ERASE_COMPLETE			= 0x81,
	REGISTRATION_COMPLETE	= 0x82
} CS_EVENTCODE;


/***********************************************************************
			J[hT[rX  ^[R[h
***********************************************************************/

typedef enum CS_RESULT {
#ifndef	SUCCESS
	SUCCESS					= 0x00,
#endif
	BAD_ADAPTER				= 0x01,
	BAD_ATTRIBUTE			= 0x02,
	BAD_BASE				= 0x03,
	BAD_EDC					= 0x04,
	Reserved0x05			= 0x05,
	BAD_IRQ					= 0x06,
	BAD_OFFSET				= 0x07,
	BAD_PAGE				= 0x08,
	READ_FAILURE			= 0x09,
	BAD_SIZE				= 0x0a,
	BAD_SOCKET				= 0x0b,
	Reserved0x0c			= 0x0c,
	BAD_TYPE				= 0x0d,
	BAD_VCC					= 0x0e,
	BAD_VPP					= 0x0f,

	Reserved0x10			= 0x10,
	BAD_WINDOW				= 0x11,
	WRITE_FAILURE			= 0x12,
	Reserved0x13			= 0x13,
	NO_CARD					= 0x14,
	UNSUPPORTED_SERVICE		= 0x15,
	UNSUPPORTED_MODE		= 0x16,
	BAD_SPEED				= 0x17,
	BUSY					= 0x18,
	GENERAL_FAILURE			= 0x19,
	WRITE_PROTECTED			= 0x1a,
	BAD_ARG_LENGTH			= 0x1b,
	BAD_ARGS				= 0x1c,
	CONFIGURATION_LOCKED	= 0x1d,
	IN_USE					= 0x1e,
	NO_MORE_ITEMS			= 0x1f,

	OUT_OF_RESOURCE			= 0x20,
	BAD_HANDLE				= 0x21,
	BAD_VERSION				= 0x22
} CS_RESULT;


/***********************************************************************
			J[hT[rX  t@NVԍ
***********************************************************************/

typedef enum CS_FUNCNO {
	CloseMemory				= 0x00,
	CopyMemory				= 0x01,
	DeregisterClient		= 0x02,
	GetClientInfo			= 0x03,
	GetConfigurationInfo	= 0x04,
	GetFirstPartition		= 0x05,
	GetFirstRegion			= 0x06,
	GetFirstTuple			= 0x07,
	GetNextPartition		= 0x08,
	GetNextRegion			= 0x09,
	GetNextTuple			= 0x0a,
	GetCardServicesInfo		= 0x0b,
	GetStatus				= 0x0c,
	GetTupleData			= 0x0d,
	GetFirstClient			= 0x0e,
	RegisterEraseQueue		= 0x0f,

	RegisterClient			= 0x10,
	ResetFunction			= 0x11,
/*	MapLogSocket			= 0x12,	*/
/*	MapLogWindow			= 0x13,	*/
	MapMemPage				= 0x14,
/*	MapPhySocket			= 0x15,	*/
/*	MapPhyWindow			= 0x16,	*/
	ModifyWindow			= 0x17,
	OpenMemory				= 0x18,
	ReadMemory				= 0x19,
	RegisterMTD				= 0x1a,
	ReleaseIO				= 0x1b,	/*  */
	ReleaseIRQ				= 0x1c,
	ReleaseWindow			= 0x1d,
	ReleaseConfiguration	= 0x1e,
	RequestIO				= 0x1f,	/* BRequestWindowp邱 */

	RequestIRQ				= 0x20,
	RequestWindow			= 0x21,
	RequestSocketMask		= 0x22,
/*	ReturnSSEntry			= 0x23,	*/
	WriteMemory				= 0x24,
	DeregisterEraseQueue	= 0x25,
	CheckEraseQueue			= 0x26,
	ModifyConfiguration		= 0x27,
	RegisterTimer			= 0x28,
	SetRegion				= 0x29,
	GetNextClient			= 0x2a,
	ValidateCIS				= 0x2b,
	RequestExclusive		= 0x2c,
	ReleaseExclusive		= 0x2d,
	GetEventMask			= 0x2e,
	ReleaseSocketMask		= 0x2f,

	RequestConfiguration	= 0x30,
	SetEventMask			= 0x31,
/*	AddSocketServices		= 0x32, */
/*	ReplaceSocketServices	= 0x33, */
	VendorSpecific			= 0x34,
/*	AdjustResourceInfo		= 0x35,	*/
	AccessConfigurationRegister	= 0x36,
	GetFirstWindow			= 0x37,
	GetNextWindow			= 0x38,
	GetMemPage				= 0x39
/*	RequestDMA				= 0x3a,	*/	/* MI-10ł̓n[hΉ */
/*	ReleaseDMA				= 0x3b	*/	/* MI-10ł̓n[hΉ */
} CS_FUNCNO;



/***********************************************************************
			J[hT[rX֐̈(ArgPointer)e
***********************************************************************/

/* ANZXx */
typedef unsigned char	ACCSPD;
/*	bit7:	'1':\łWaitgp */
#define	ACCSPD_WAIT		0x80
/*	bit6-3:	x̉ */
/*	bit2-0:	ibit6-3OȊȌꍇjx̎w
/*			ibit6-3ȌꍇjfoCXxR[h */
#define	ACCSPD_250NSEC	1
#define	ACCSPD_200NSEC	2
#define	ACCSPD_150NSEC	3
#define	ACCSPD_100NSEC	4


/* Cxg}XN */
typedef	unsigned short	CSEVMSK;
#define	EMSK_WRITE_PROTECT		0x0001
#define	EMSK_CARD_LOCK_CHANGE	0x0002
#define	EMSK_EJECTION_REQUEST	0x0004
#define	EMSK_INSERTION_REQUEST	0x0008
#define	EMSK_BATTERY_DEAD		0x0010
#define	EMSK_BATTERY_LOW		0x0020
#define	EMSK_READY_CHANGE		0x0040
#define	EMSK_CARD_DETECT_CHANGE	0x0080
#define	EMSK_PM_CHANGE			0x0100
#define	EMSK_RESET_EVENTS		0x0200
#define	EMSK_SS_UPDATE			0x0400


/*--------------------------------------------------------------------*/
typedef struct ARG_AccessConfigurationRegister {
	UWORD	Socket;
	UBYTE	Action;
	UBYTE	Offset;
	UBYTE	Value;
} ARG_AccessConfigurationRegister;

#define ARGLEN_AccessConfigurationRegister	\
		sizeof(ARG_AccessConfigurationRegister)

/** .Action **/
#define	ACT_READ	0x00	/* ǂݍ */
#define	ACR_WRITE	0x01	/*  */


/*--------------------------------------------------------------------*/
typedef struct ARG_CopyMemory {
	ULONG	SourceOffset;
	ULONG	DestOffset;
	ULONG	Count;
	UWORD	Attributes;
} ARG_CopyMemory;

#define	ARGLEN_CopyMemory	sizeof(ARG_CopyMemory)

/** .Attributes **/
#define	ATR_DISABLE_ERASE_BEFORE_WRITE	0x04
#define	ATR_VERIFY_AFTER_WRITE			0x08


/*--------------------------------------------------------------------*/
typedef struct ARG_GetCardServicesInfo {
	UWORD	InfoLen;
	UBYTE	Signature[2];	/* [0]='C', [1]='S' */
	UWORD	Count;
	UWORD	Revision;
	UWORD	CSLevel;
	UWORD	VStrOff;
	UWORD	VStrLen;
	UWORD   FuncsPerSkt;
	UBYTE	VendorString[8];
} ARG_GetCardServicesInfo;

#define	ARGLEN_GetCardServicesInfo sizeof(ARG_GetCardServicesInfo)


/*--------------------------------------------------------------------*/
typedef struct ARG_GetClientInfoSmall {
	UWORD	MaxLen;
	UWORD	InfoLen;
	UWORD	Attributes;
} ARG_GetClientInfoSmall;

typedef struct ARG_GetClientInfoLarge {
	UWORD	MaxLen;
	UWORD	InfoLen;
	UWORD	Attributes;
	UWORD	Revision;
	UWORD	CSLevel;
	UWORD	RevDate;	/* bit15-9:N^bit8-5:^bit4-0 */
	UWORD	NameOff;
	UWORD	NameLen;
	UWORD	VStringOff;
	UWORD	VStringLen;
	UBYTE	NameString[16];
	UBYTE	VendorString[16];
} ARG_GetClientInfoLarge;

typedef union ARG_GetClientInfo {
	ARG_GetClientInfoSmall	Small;
	ARG_GetClientInfoLarge	Large;
} ARG_GetClientInfo;

#define	ARGLEN_GetClientInfoS	sizeof(ARG_GetClientInfoSmall)
#define	ARGLEN_GetClientInfoL	sizeof(ARG_GetClientInfoLarge)


/*--------------------------------------------------------------------*/
typedef struct ARG_GetConfigurationInfo {
	UWORD	Socket;			/* RequestConfiguration()Ɠ */
	UWORD	Attributes;		/*  */
	UBYTE	Vcc;			/*  */
	UBYTE	Vpp1;			/*  */
	UBYTE	Vpp2;			/*  */
	UBYTE	IntType;		/*  */
	ADDRESS	ConfigBase;		/*  8(offset) */
	UBYTE	Status;
	UBYTE	Pin;
	UBYTE	Copy;
	UBYTE	Option;
	UBYTE	Present;
	UBYTE	FirstDevType;
	UBYTE	FuncCode;
	UBYTE	SysInitMask;
	UWORD	ManufCode;		/* 20 */
	UWORD	ManufInfo;
	UBYTE	CardValues;
	UBYTE	AssignedIRQ;
	UWORD	IRQAttributes;
	UWORD	BasePort1;
	UBYTE	NumPorts1;		/* 30 */
	UBYTE	Attributes1;
	UWORD	BasePort2;
	UBYTE	NumPorts2;
	UBYTE	Attributes2;
	UBYTE	IOAddrLines;	/* 36 */
} ARG_GetConfigurationInfo;

#define	ARGLEN_GetConfigurationInfo	sizeof(ARG_GetConfigurationInfo)

/** .Attributes ǉtB[h **/
#define	ATR_EXCLUSIVE_USED	0x0001
#define	ATR_VALID_CLIENT	0x0100

/** .FirstDevType/.FuncCode/.SysInitMask/.ManufCode/.ManufInfo **/
#define	NO_INFO		0x0ff

/** .CardValues **/
#define	CARDVAL_OPTION_VALUE_VALID			0x01	/* .Optione͗L */
#define	CARDVAL_STATUS_VALUE_VALID			0x02	/* .Statuse͗L */
#define	CARDVAL_PIN_REPLACEMENT_VALUE_VALID	0x04	/* .Pine͗L */
#define	CARDVAL_COPY_VALUE_VALID			0x08	/* .Copye͗L */


/*--------------------------------------------------------------------*/
typedef struct ARG_GetEventMask {
	UWORD	Attributes;
	CSEVMSK	EventMask;
	UWORD	Socket;
} ARG_GetEventMask;

#define	ARGLEN_GetEventMask	sizeof(ARG_GetEventMask)

/** .Attributes **/
#define	ATR_EVENT_MASK_FOR_SOCKET 0x01 /* ̃\Pbĝ݂̃Cxg}XN */

/** .EventMask **/
/* typedef CSEVMSK t߂Œ` */


/*--------------------------------------------------------------------*/
typedef struct ARG_GetFirstClient {
	UWORD	Socket;
	UWORD	Attributes;
} ARG_GetFirstClient;

#define	ARGLEN_GetFirstClient	sizeof(ARG_GetFirstClient)

/** .Attributes **/
#define	ATR_ALL_CLIENTS		 0x0000	/* bit0='0': SẴNCAg */
#define	ATR_THIS_SOCKET_ONLY 0x0001	/* bit0='1': ̃\Pbg̃NCAg */	


/*--------------------------------------------------------------------*/
typedef struct ARG_GetFirstPartition {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	TupleMask;
	ACCSPD	AccessSpeed;
	UWORD	Flags;
	ULONG	LinkOffset;
	ULONG	CISOffset;
	ULONG	CardOffset;
	ULONG	PartSize;
	ULONG	EffBlockSize;
	UWORD	PartMultiple;
	UWORD	JEDECID;
	UWORD	PartType;
} ARG_GetFirstPartition;

#define	ARGLEN_GetFirstPartition	sizeof(ARG_GetFirstPartition)

/** .Attributes **/
#define	ATR_MEM_COMMON			0x0000	/* bit0='0': R */
#define	ATR_MEM_ATTRIBUTE		0x0001	/* bit0='1': Agr[g */
#define	ATR_VIRTUAL_PARTITION	0x0100
#define	ATR_WRITE_WITHOUT_ERASE	0x0000	/* bit10-9='00' Ȃ̏ */	
#define	ATR_WRITE_WITH_ERASE	0x0200	/* bit10-9='01' t̏ */	
/* #define	ATR_Reserved		0x0400*//* bit10-9='10' \ */	
#define	ATR_WRITE_WITH_DISABLEABLE_ERASE	0x0600
									/* bit10-9='11' ֎~\ȏ */	
/** .TupleMask **/
#define	TPLMSK_ACCESS_SPEED	  0x01	/*'1':ANZXxTuple擾*/
#define	TPLMSK_CARD_OFFSET	  0x02	/*'1':J[hItZbgTuple擾*/
#define	TPLMSK_PART_SIZE	  0x04	/*'1':p[eBVTCYTuple擾*/
#define	TPLMSK_EFF_BLOCK_SIZE 0x08	/*'1':ubNTCYTuple擾*/
#define	TPLMSK_PART_MULTIPLE  0x10	/*'1':ŏp[eBVTCYTuple擾*/
#define	TPLMSK_JEDEC_ID		  0x20	/*'1':JEDEC IDTuple擾*/
#define	TPLMSK_PART_TYPE	  0x40	/*'1':p[eBV^CvTuple擾*/
#define	TPLMSK_RESERVED		  0x80	/* \ */

/** .AccessSpeed **/
/* typedef ACCSPD ̋߂Œ` */

/** .PartType **/
#define	PTYPE_NO_PARTITION_INFO_TUPLE 0x0000 /* p[eBVeȂ */
#define	PTYPE_DOS_BPBFAT			  0x0001 /* DOS BPB/FATp[eBV */
#define	PTYPE_FFS_I					  0x0002 /* FFS Ip[eBV */
#define	PTYPE_FFS_II				  0x0003 /* FFS IIp[eBV */
#define	PTYPE_XIP					  0x0004 /* XIPp[eBV */
#define	PTYPE_UNKNOWN				  0x7FFF /* m̃p[eBV */


/*--------------------------------------------------------------------*/
/* PartTypeo GetFirstPartitionƓ */
typedef struct ARG_GetFirstRegion {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	TupleMask;
	ACCSPD	AccessSpeed;
	UWORD	Flags;
	ULONG	LinkOffset;
	ULONG	CISOffset;
	ULONG	CardOffset;
	ULONG	PartSize;
	ULONG	EffBlockSize;
	UWORD	PartMultiple;
	UWORD	JEDECID;
} ARG_GetFirstRegion;

#define	ARGLEN_GetFirstRegion	sizeof(ARG_GetFirstRegion)


/*--------------------------------------------------------------------*/
typedef struct ARG_GetFirstTuple {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	DesiredTuple;
	UBYTE	Reserved;		/* \: '0' */
	UWORD	Flags;
	ULONG	LinkOffset;
	ULONG	CISOffset;
	UBYTE	TupleCode;
	UBYTE	TupleLink;
} ARG_GetFirstTuple;

#define	ARGLEN_GetFirstTuple	sizeof(ARG_GetFirstTuple)

/** .Attributes **/
#define	ATR_RETURN_LINK_TUPLES	0x0001	/* long link̂߂TupleԂ */


/*--------------------------------------------------------------------*/
typedef	ARG_GetFirstClient	ARG_GetNextClient;

#define	ARGLEN_GetNextClient	sizeof(ARG_GetNextClient)


/*--------------------------------------------------------------------*/
typedef	ARG_GetFirstPartition	ARG_GetNextPartition;

#define	ARGLEN_GetNextPartition	sizeof(ARG_GetNextPartition)


/*--------------------------------------------------------------------*/
typedef	ARG_GetFirstRegion	ARG_GetNextRegion;

#define	ARGLEN_GetNextRegion	sizeof(ARG_GetNextRegion)


/*--------------------------------------------------------------------*/
typedef	ARG_GetFirstTuple	ARG_GetNextTuple;

#define	ARGLEN_GetNextTuple	sizeof(ARG_GetNextTuple)


/*--------------------------------------------------------------------*/
typedef struct ARG_GetStatus {
	UWORD	Socket;
	UWORD	CardState;
	UWORD	SocketState;
} ARG_GetStatus;

#define	ARGLEN_GetStatus	sizeof(ARG_GetStatus)

/** .CardState **/
#define	CDST_WRITE_PROTECTED			0x0001	/* ݕی */
#define	CDST_CARD_LOCKED				0x0002	/* J[hbN */
#define	CDST_EJECTION_REQUEST			0x0004	/* rov */
#define	CDST_INSERTION_REQUEST			0x0008	/* }v */
#define	CDST_BATTERY_VOLTAGE_DETECT1	0x0010	/* drdoP */
#define	CDST_BATTERY_VOLTAGE_DETECT2	0x0020	/* drdoQ */
#define	CDST_READY_BUSY					0x0040	/* ^gp */
#define	CDST_CARD_DETECTED				0x0080	/* J[ho */

/** .SocketState **/
#define	SKST_WRITE_PROTECTED_CHANGE		0x0001	/* ݕیω */
#define	SKST_CARD_LOCKED_CHANGE			0x0002	/* J[hbNω */
#define	SKST_EJECTION_REQUEST_PENDING	0x0004	/* rovۗ */
#define	SKST_INSERTION_REQUEST_PENDING	0x0008	/* }vۗ */
#define	SKST_BATTERY_DEAD_CHANGE		0x0010	/* dr͊ω */
#define	SKST_BATTERY_WARNING_CHANGE		0x0020	/* drω */
#define	SKST_READY_CHANGE				0x0040	/* ω */
#define	SKST_CARD_DETECTED_CHANGE		0x0080	/* J[hoω */


/*--------------------------------------------------------------------*/
typedef struct ARG_GetTupleData {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	DesiredTuple;
	UBYTE	TupleOffset;
	UWORD	Flags;
	ULONG	LinkOffset;
	ULONG	CISOffset;
	UWORD	TupleDataMax;
	UWORD	TupleDataLen;
	UBYTE	TupleData[256];
} ARG_GetTupleData;

#define	ARGLEN_GetTupleData	sizeof(ARG_GetTupleData)


/*--------------------------------------------------------------------*/
typedef struct ARG_MapMemPage {
	ULONG	CardOffset;
	UBYTE	Page;
} ARG_MapMemPage;

#define	ARGLEN_MapMemPage	sizeof(ARG_MapMemPage)


/*--------------------------------------------------------------------*/
typedef struct ARG_ModifyConfiguration {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	Vcc;
	UBYTE	Vpp1;
	UBYTE	Vpp2;
} ARG_ModifyConfiguration;

#define	ARGLEN_ModifyConfiguration	sizeof(ARG_ModifyConfiguration)

/** .Attributes **/
#if	DUP_DEF
#define	ATR_ENABLE_IRQ_STEERING	0x0002	/* IRQ蓖ċ */
#endif
#define	ATR_IRQ_CHANGE_VALID	0x0004	/* IRQύXv */
#define	ATR_VCC_CHANGE_VALID	0x0008	/* VccύXv */
#define	ATR_VPP1_CHANGE_VALID	0x0010	/* Vpp1ύXv */
#define	ATR_VPP2_CHANGE_VALID	0x0020	/* Vpp2ύXv */


/*--------------------------------------------------------------------*/
typedef struct ARG_ModifyWindow {
	UWORD	Attributes;
	ACCSPD	AccessSpeed;
} ARG_ModifyWindow;

#define	ARGLEN_ModifyWindow	sizeof(ARG_ModifyWindow)

/** .Attributes **/
#define	ATR_MEMTYPE_COMMON		0x0000	/* bit1='0': R */
#define	ATR_MEMTYPE_ATTRIBUTE	0x0002	/* bit1='1': Agr[g */
#define	ATR_ENABLE				0x0004	/* '1': enable */
#define	ATR_ACCESS_SPEED_VALID	0x0008	/* '1': .AccessSpeedoL */

/** .AccessSpeed **/
/* typedef ACCSPD ̋߂Œ` */


/*--------------------------------------------------------------------*/
typedef struct ARG_OpenMemory {
	UWORD	Socket;
	UWORD	Attributes;
	ULONG	Offset;
} ARG_OpenMemory;

#define	ARGLEN_OpenMemory	sizeof(ARG_OpenMemory)

/** .Attributes **/
#define	ATR_COMMON_MEM		0x0000	/* bit0='0':R */	
#define	ATR_ATTRIBUTE_MEM	0x0001	/* bit0='1':Agr[g */
#define	ATR_EXCLUSIVE		0x0002	/* r */


/*--------------------------------------------------------------------*/
typedef struct ARG_ReadMemory {
	ULONG	CardOffset;
	ULONG	Count;
} ARG_ReadMemory;

#define	ARGLEN_ReadMemory	sizeof(ARG_ReadMemory)


/*--------------------------------------------------------------------*/
typedef struct ARG_RegisterClient {
	UWORD	Attributes;
	CSEVMSK	EventMask;
	ADDRESS	ClientData[2];	/* R[obNɓnf[^ */
	UWORD	Version;
} ARG_RegisterClient;

/* PgǋL */
/* ClientData[]ɂ́AʏANCAg̃[N擪AhX */

#define	ARGLEN_RegisterClient	sizeof(ARG_RegisterClient)

/** .Attributes **/
#define	ATR_MEMORY_CLIENT_DEVICE_DRIVER	0x0001	/*(1) (1),(2),(3)͔rI */
#define	ATR_MEMORY_TECHNOLOGY_DRIVER	0x0002	/*(2)*/
#define	ATR_IO_CLIENT_DEVICE_DRIVER		0x0004	/*(3)*/
#define	ATR_CARD_INSERTION_SHARABLE		0x0008
#define	ATR_CARD_INSERTION_EXCLUSIVE	0x0010

/** .EventMask **/
/* typedef CSEVMSK t߂Œ` */


/*--------------------------------------------------------------------*/
typedef struct CSERASEQUEUE {
	UWORD	Handle;
	UBYTE	EntryState;
	UBYTE	Size;		/* 2^nn(w)  64KbyteȂ16w肷 */
	ULONG	Offset;
	ULONG	Optional;
} CSERASEQUEUE;

typedef struct ARG_RegisterEraseQueue {
	UWORD			QueueEntryLen;
	UWORD			QueueEntryCnt;
	CSERASEQUEUE	QueueEntryArray[1]; /* ?? Nishida */
} ARG_RegisterEraseQueue;

#define	ARGLEN_RegisterEraseQueue	sizeof(ARG_RegisterEraseQueue)

/** .QueueEntryArray[n].EntryState **/
#define	IDLE					0xff
#define	QUEUED_FOR_ERASE		0x00
#define	ERASE_IN_PROGRESS		0x01	/* 0x01`0x7f */
#define	ERASE_PASSED			0xe0	
#define	ERASE_FAILED			0xe1
#define	MEDIA_WRITE_PROTECTED	0x84
#define	MEDIA_NOT_ERASABLE		0x86
#define	MEDIA_MISSING			0x80
#define	MEDIA_NOT_WRITABLE		0x87
#define	BAD_SOCKET				0xc3
#define	BAD_TECHNOLOGY			0xc2
#define	BAD_OFFSET				0xc1
#define	BAD_VCC					0xc4
#define	BAD_VPP					0xc4
#define	BAD_SIZE				0xc6


/*--------------------------------------------------------------------*/
typedef struct ARG_RegisterMTD {
	UWORD	Socket;
	UWORD	Attributes;
	UBYTE	Offset;
	UBYTE	MTDMediaID;
} ARG_RegisterMTD;

#define	ARGLEN_RegisterMTD	sizeof(ARG_RegisterMTD)

/** .Attributes **/
#if	DUP_DEF
#define	ATR_COMMON_MEM			0x0000	/* bit0='0':R */	
#define	ATR_ATTRIBUTE_MEM		0x0001	/* bit0='1':Agr[g */
#define	ATR_WRITE_WITHOUT_ERASE	0x0000	/* bit10-9='00' Ȃ̏ */	
#define	ATR_WRITE_WITH_ERASE	0x0200	/* bit10-9='01' t̏ */	
/* #define	ATR_Reserved		0x0400*//* bit10-9='10' \ */	
#define	ATR_WRITE_WITH_DISABLEABLE_ERASE	0x0600
									/* bit10-9='11' ֎~\ȏ */
#endif	/* #if DUP_DEF */
#define	ATR_WRITE_WITH_VERIFY	0x0800	/* bit11='1':Verifyt̏ */
#define	ATR_ERASE_REQUEST_SUPPORTED	0x1000	/* bit12='1':v\ */


/*--------------------------------------------------------------------*/
typedef struct ARG_RegisterTimer {
	UWORD	Wait;
} ARG_RegisterTimer;

#define	ARGLEN_RegisterTimer	sizeof(ARG_RegisterTimer)


/*--------------------------------------------------------------------*/
typedef struct ARG_ReleaseConfiguration {
	UWORD	Socket;
} ARG_ReleaseConfiguration;

#define	ARGLEN_ReleaseConfiguration	sizeof(ARG_ReleaseConfiguration)


/*--------------------------------------------------------------------*/
typedef struct ARG_ReleaseExclusive {
	UWORD	Socket;
	UWORD	Attributes;		/* \: ɂOɂׂ */
} ARG_ReleaseExclusive;

#define	ARGLEN_ReleaseExclusive	sizeof(ARG_ReleaseExclusive)


/*--------------------------------------------------------------------*/
typedef struct ARG_ReleaseIO {
	UWORD	Socket;
	UWORD	BasePort1;
	UBYTE	NumPorts1;
	UBYTE	Attributes1;	/* RequestIO()Ɠ */
	UWORD	BasePort2;
	UBYTE	NumPorts2;
	UBYTE	Attributes2;	/* RequestIO()Ɠ */
	UBYTE	IOAddrLines;
} ARG_ReleaseIO;

#define	ARGLEN_ReleaseIO	sizeof(ARG_ReleaseIO)

/** .Attributes **/
#define	IOATR_SHARED					0x0001	/* bit0: p */
#define	IOATR_FIRST_SHARED				0x0002	/* bit1: ߂Ă̋p */
#define	IOATR_FORCE_ALIAS_ACCESSIBILITY	0x0004	/* bit2: ʖANZX */
#define	IOATR_WIDTH_8BIT				0x0000	/* bit3='0': I/OԂ8bit */
#define	IOATR_WIDTH_16BIT				0x0008	/* bit3='1': I/OԂ16bit */


/*--------------------------------------------------------------------*/
typedef struct ARG_ReleaseIRQ {
	UWORD	Socket;
	UWORD	Attributes;		/* RequestIRQ()Ɠ */
	UBYTE	AssignedIRQ;
} ARG_ReleaseIRQ;

#define	ARGLEN_ReleaseIRQ	sizeof(ARG_ReleaseIRQ)


/*--------------------------------------------------------------------*/
typedef struct ARG_ReleaseSocketMask {
	UWORD	Socket;
} ARG_ReleaseSocketMask;

#define	ARGLEN_ReleaseSocketMask	sizeof(ARG_ReleaseSocketMask)


/*--------------------------------------------------------------------*/
typedef struct ARG_RequestConfiguration {
	UWORD	Socket;			/* GetConfiguration()Ɠ */
	UWORD	Attributes;		/*  */
	UBYTE	Vcc;			/*  */
	UBYTE	Vpp1;			/*  */
	UBYTE	Vpp2;			/*  */
	UBYTE	IntType;		/*  */
	ADDRESS	ConfigBase;		/*  8(offset) */
	UBYTE	Status;
	UBYTE	Pin;
	UBYTE	Copy;
	UBYTE	ConfigIndex;
	UBYTE	Present;
} ARG_RequestConfiguration;

#define	ARGLEN_RequestConfiguration	sizeof(ARG_RequestConfiguration)

/** .Attributes **/
#define	ATR_ENABLE_IRQ_STEERING	0x0002	/* IRQ蓖ċ */

/* ȉ̃J[hRtBM[VWX^̉ */
/* p: PC-Card Standard 95/2 Vol.2 Electrical Specification p.52 */
/* a: PCMCIA Ver4.1 JEIDA 1991 p.2-79 */
/** .Status **/
#define	CCSR_INTRACK	0x01	/* bit0: R/W */
#define	CCSR_INTR		0x02	/* bit1: R or R/W */
#define	CCSR_PWRDWN		0x04	/* bit2: R/W */
#define	CCSR_AUDIO		0x08	/* bit3: R/W */
#define	CCSR_RFU		0x10	/* bit4: reserved '0'ɃZbg */
#define	CCSR_IOIS8		0x20	/* bit5: R/W */
#define	CCSR_SIGCHG		0x40	/* bit6: R/W */
#define	CCSR_CHANGED	0x80	/* bit7: R */

/** .Pin **/
#define	PRR_RWPROT		0x01	/* bit0: */
#define	PRR_RREADY		0x02	/* bit1: */
#define	PRR_RBVD2		0x04	/* bit2: */
#define	PRR_RBVD1		0x08	/* bit3: */
#define	PRR_CWPROT		0x10	/* bit4: */
#define	PRR_CREADY		0x20	/* bit5: */
#define	PRR_CBVD2		0x40	/* bit6: */
#define	PRR_CBVD1		0x80	/* bit7: */

/** .Copy **/
/* bit3-0: Socket Number */
/* bit6-4: Copy Number */

/** .ConfigIndex **/
/* bit5-0: Configuration Index */
#define	COR_LEVELIRQ	0x40	/* bit6='1':x荞/'0':pX荞X */
/* #define COR_SRESET	0x80	gׂł͂ȂBJ[hT[rXResetCard
   								gp邱 */

/** .Presetnt **/
#define	PRESENT_OPTION			0x01 /* Config.IvVWX^ */
#define	PRESENT_STATUS			0x02 /* Config.Xe[^XWX^ */
#define	PRESENT_PIN_REPLACEMENT	0x04 /* szuWX^ */
#define	PRESENT_COPY			0x08 /* \PbgRs[WX^ */

/** .IntType **/
#define	INTTYPE_MEMORY			0x01	/* bit0='1': */
#define	INTTYPE_MEMORY_AND_IO	0x02	/* bit1='1':I/O */


/*--------------------------------------------------------------------*/
typedef struct ARG_RequestExclusive {
	UWORD	Socket;
	UWORD	Attributes;		/* \: ɂOɂׂ */
} ARG_RequestExclusive;

#define	ARGLEN_RequestExclusive	sizeof(ARG_RequestExclusive)


/*--------------------------------------------------------------------*/
typedef ARG_ReleaseIO ARG_RequestIO;	/* ARG_ReleaseIOQƂ̂ */

#define	ARGLEN_RequestIO	sizeof(ARG_RequestIO)


/*--------------------------------------------------------------------*/
typedef struct ARG_RequestIRQ {
	UWORD	Socket;
	UWORD	Attributes;		/* RequestIRQ()Ɠ */
	UBYTE	AssignedIRQ;
	UBYTE	IRQInfo1;
	UWORD	IRQInfo2;
} ARG_RequestIRQ;

#define	ARGLEN_RequestIRQ	sizeof(ARG_RequestIRQ)

/** .Attributes **/
#define	IRQATR_EXCLUSIVE				0x0000	/* bit1-0='00' */
#define	IRQATR_TIME_MULTIPLEXED_SHARING	0x0001	/* bit1-0='01' */
#define	IRQATR_DYNAMIC_SHARING			0x0002	/* bit1-0='10' */
#define	IRQATR_FORCE_PULSE				0x0004	/* bit2 */
#define	IRQATR_FIRST_SHARED				0x0008	/* bit3 */
#define	IRQATR_PULSE_IRQ_ALLOCATED		0x0100	/* bit8 */

/** .IRQInfo1 **/
/* bit4='0'̏ꍇAbit3-0 IRQxi0`15j\A.IRQInfo2 ͈Ӗ
   ȂB
   bit4='1'̏ꍇA.IRQInfo1 ͈ȉ̈ӖB
*/
#define	IRQINFO1_IRQINFO2_VALID		0x10	/* bit4='1' */
#define	IRQINFO1_NMI	0x01	/* bit0 */
#define	IRQINFO1_IOCK	0x02	/* bit1 */
#define	IRQINFO1_BERR	0x04	/* bit2 */
#define	IRQINFO1_VEND	0x08	/* bit3 */
#define	IRQINFO1_LEVEL	0x20	/* bit5 */
#define	IRQINFO1_PULSE	0x40	/* bit6 */
#define	IRQINFO1_SHARE	0x80	/* bit7 */

/** .IRQInfo2 **/
/* .IRQInfo1bit4='1'̏ꍇA.IRQInfo2͈ȉ̈Ӗ */
#define	IRQINFO2_IRQ0	0x0001	/* bit 0 */
#define	IRQINFO2_IRQ1	0x0002	/* bit 1 */
#define	IRQINFO2_IRQ2	0x0004	/* bit 2 */
#define	IRQINFO2_IRQ3	0x0008	/* bit 3 */
#define	IRQINFO2_IRQ4	0x0010	/* bit 4 */
#define	IRQINFO2_IRQ5	0x0020	/* bit 5 */
#define	IRQINFO2_IRQ6	0x0040	/* bit 6 */
#define	IRQINFO2_IRQ7	0x0080	/* bit 7 */
#define	IRQINFO2_IRQ8	0x0100	/* bit 8 */
#define	IRQINFO2_IRQ9	0x0200	/* bit 9 */
#define	IRQINFO2_IRQ10	0x0400	/* bit10 */
#define	IRQINFO2_IRQ11	0x0800	/* bit11 */
#define	IRQINFO2_IRQ12	0x1000	/* bit12 */
#define	IRQINFO2_IRQ13	0x2000	/* bit13 */
#define	IRQINFO2_IRQ14	0x4000	/* bit14 */
#define	IRQINFO2_IRQ15	0x8000	/* bit15 */


/*--------------------------------------------------------------------*/
typedef struct ARG_RequestSocketMask {
	UWORD	Socket;
	CSEVMSK	EventMask;
} ARG_RequestSocketMask;

#define	ARGLEN_RequestSocketMask	sizeof(ARG_RequestSocketMask)

/** .EventMask **/
/* typedef CSEVMSK t߂Œ`Ă */


/*--------------------------------------------------------------------*/
typedef union ACCSPDIOADRL {
	  ACCSPD	AccessSpeed;
	  UBYTE		IOAddrLines;
} ACCSPDIOADRL;

typedef struct ARG_RequestWindow {
	UWORD	Socket;
	UWORD	Attributes;
	ADDRESS	Base;
	ULONG	Size;
	ACCSPDIOADRL u;
} ARG_RequestWindow;

#define	ARGLEN_RequestWindow	sizeof(ARG_RequestWindow)

/** .Attributes **/
#define	ATR_ADR_SPACE_MEM		0x0000	/* bit0='0':  */
#define	ATR_ADR_SPACE_IO		0x0001	/* bit0='1': I/O */
#if	DUP_DEF
#define	ATR_MEMTYPE_COMMON		0x0000	/* bit1='0': R */
#define	ATR_MEMTYPE_ATTRIBUTE	0x0002	/*      '1': Agr[g */
#define	ATR_ENABLE				0x0004	/* bit2='1': enable */
#endif
#define	ATR_DATA_WIDTH_8BIT		0x0000	/* bit3='0': f[^oX 8bit */
#define	ATR_DATA_WIDTH_16BIT	0x0008	/* bit3='0': f[^oX 8bit */
#define	ATR_SHARED				0x0010	/* bit4='1': p */
#define	ATR_FIRST_SHARED		0x0020	/* bit5='1': ߂Ă̋p */
#define	ATR_BINDING_SPECIFIC	0x0040	/* bit6='1': Ɉˑ */
#define	ATR_CARD_OFFSETS_ARE_WINDOW_SIZED \
								0x0100	/* bit8='1': */

/** .AccessSpeed **/
/* typedef ACCSPD t߂Œ` */ 


/*--------------------------------------------------------------------*/
typedef struct ARG_ResetFunction {
	UWORD	Socket;
	UWORD	Attributes;		/* \: ɂOɂׂ */
} ARG_ResetFunction;

#define	ARGLEN_ResetFunction	sizeof(ARG_ResetFunction)


/*--------------------------------------------------------------------*/
typedef struct ARG_SetEventMask {
	UWORD	Attributes;
	CSEVMSK	EventMask;
	UWORD	Socket;
} ARG_SetEventMask;

#define	ARGLEN_SetEventMask	sizeof(ARG_SetEventMask)

/** .Attributes **/
#if	DUP_DEF
#define	ATR_EVENT_MASK_FOR_SOCKET 0x01 /* ̃\Pbĝ݂̃Cxg}XN */
#endif

/** .EventMask **/
/* typedef CSEVMSK t߂Œ` */


/*--------------------------------------------------------------------*/
typedef struct ARG_SetRegion {
	UWORD	Socket;
	UWORD	Attributes;
	ULONG	CardOffset;
	ULONG	RegionSize;
	ULONG	EffBlockSize;
	UWORD	PartMultiple;
	UWORD	JEDECID;
	ULONG	BiasOffset;
	ACCSPD	AccessSpeed;
} ARG_SetRegion;

#define	ARGLEN_SetRegion	sizeof(ARG_SetRegion)

/** .Attributes **/
#if	DUP_DEF
#define	ATR_MEM_COMMON		0x0000	/* bit0='0': R */
#define	ATR_MEM_ATTRIBUTE	0x0001	/* bit0='1': Agr[g */
#endif
#define	ATR_DELETE_REGION	0x0002	/* bit1='1': ̈揜 */
#define	ATR_VIRTUAL_REGION	0x0100	/* bit8='1': z̈ */


/*--------------------------------------------------------------------*/
typedef struct ARG_ValidateCIS {
	UWORD	Socket;
	UWORD	Chains;
} ARG_ValidateCIS;

#define	ARGLEN_ValidateCIS	sizeof(ARG_ValidateCIS)


/*--------------------------------------------------------------------*/
typedef enum PCCARDIRQLEVEL {
	PCCARD_IRQ_RAPID = 11,	/* 荞 */
	PCCARD_IRQ_STD   = 9	/* ʏ튄荞(bZ[WT[ogp) */
} PCCARDIRQLEVEL;

typedef struct ARGEXT_IRQInfo {
	PCCARDIRQLEVEL	Level;	/*(p)ݒ肷銄荞݃x */
	PROC	ProcEntry;		/*(p)荞݃T[rX[`̃GgAhX */
	void	*InfoAdr;		/*(p)荞݃T[rX[`֓nAhX */
} ARGEXT_IRQInfo;

typedef ULONG PCCARDTYPE;
typedef	UCHAR PCCARDNAME[62];	/* ̓sŐ݂Ă */

typedef struct ARGEXT_PCCardInfo {
	PCCARDTYPE	PCCardType;	/*(p)PC-Card̎ʂ\ */
	USHORT	Socket;			/*(p)_\Pbgԍ */
	UCHAR	MajorRevNo;		/*(p)Major Revision Number */
	UCHAR	MinorRevNo;		/*(p)Minor ... */
	PCCARDNAME	Info;		/*(p) [J[A@햼Ȃ (CIS)*/
	ULONG	Rsv[4];			/*(p)gp 0Ă */
} ARGEXT_PCCardInfo;

typedef struct ARGEXT_ExchgOff {
	USHORT	Socket;		/*(p)_\Pbgԍ */
	UCHAR	State;		/*(r) */
	UCHAR	Wp;			/*(r)Write Protect*/
} ARGEXT_ExchgOff;

/** .StateiJ[h݂̑̕ωj**/
#define	PCCARDEXG_KEEP_VACANT	(UCHAR)0x00	/* 0b000 OFFOuv܂ */
#define	PCCARDEXG_KEEP_INSERTED	(UCHAR)0x01	/* 0b001 OFFO}܂ */
#define	PCCARDEXG_INSERTED		(UCHAR)0x05	/* 0b101 OFFɑ}ꂽ */
#define	PCCARDEXG_REMOVED		(UCHAR)0x06	/* 0b110 OFFɔꂽ */
#define	PCCARDEXG_EXCHANGED		(UCHAR)0x07	/* 0b111 OFFɌꂽ */

/** .WpiWrite ProtectԂ̕ωj **/
#define	PCCARDWP_NOT_CHANGED	(UCHAR)0x00 /* OFFOő삳ĂȂ */
#define	PCCARDWP_CHANGED		(UCHAR)0x01	/* OFFOő삳ꂽ */


typedef	union ARGVSINFO {
	ARGEXT_IRQInfo		Irq;
	ARGEXT_PCCardInfo	CardInfo;
	ARGEXT_ExchgOff		ExchgOff;
} ARGVSINFO;

typedef struct ARG_VendorSpecific {
	UWORD	InfoLen;		/* V{ VENDS_INFO_LEN̒l */
	UWORD	ServiceCode;	/* ZAURUS CardServicesƎ̃T[rXR[h */
	ARGVSINFO Info;
} ARG_VendorSpecific;

#define ARGLEN_VendorSpecific	sizeof(ARG_VendorSpecific)

/** .InfoLen **/
#define	VENDS_INFO_LEN	(ARGLEN_VendorSpecific-sizeof(UWORD))

/** .ServiceCode **/
#define	VENDS_SET_IRQ_VECTOR		0x0000	/* 荞݃xN^ݒ肷 */
#define	VENDS_CLEAR_IRQ_VECTOR		0x0001	/* 荞݃xN^폜 */
#define	VENDS_SET_PCCARD_INFO		0x0002	/* PC-Card̎ʂo^ */
#define	VENDS_GET_PCCARD_INFO		0x0003	/* PC-Card̎ʂ擾 */
#define	VENDS_GET_EXCHG_DURING_OFF	0x0004	/* OFF̑},,m */


/*--------------------------------------------------------------------*/
typedef struct ARG_WriteMemory {
	ULONG	CardOffset;
	ULONG	Count;
	UWORD	Attributes;
} ARG_WriteMemory;

#define	ARGLEN_WriteMemory	sizeof(ARG_WriteMemory)

/** .Attributes **/
#define	ATR_DISABLE_ERASE	0x0004
#define	ATR_VERIFY			0x0008


/***********************************************************************
			J[hT[rXCu֐vg^Cv錾
***********************************************************************/

typedef UINT	*CS_HDL;
typedef	void	*CS_PTR;
typedef UINT	CS_ARGLEN;
typedef	void	*CS_ARGPTR;

CS_RESULT CardServices( CS_FUNCNO, CS_HDL, CS_PTR, CS_ARGLEN, CS_ARGPTR );



/***********************************************************************
						R[obN֐p`
 
	CS_RESULT Callback( CS_EVENTCODE	EventNo,
						USHORT			SocketNo,
						int				Info,
						MTDREQUEST		*pMTDRequest,
						void			*pBuffer,
						int				Misc,
						ADDRESS			*pClientData
					   );
***********************************************************************/
 
typedef struct MTDREQUEST {
	UWORD	Length;
	UWORD	LogicalSocket;
	ULONG	SrcCardOffset;
	ULONG	DestCardOffset;
	ULONG	TransferLength;
	UBYTE	Function;
	UBYTE	AccessSpeed;
	UWORD	MTDID;
	UWORD	MTDStatus;
/*	void	*MAT[20]; */
} MTDREQUEST;


/***********************************************************************
			̑AJ[hT[rX֌W̒`
***********************************************************************/

#define	CARDSVC_REL_NO	0	/* [Xԍ */


#undef	DUP_DEF

#endif /* #ifndef _CARDSVC_H_INCLUDED */

