/*
		      ANSI C Runtime Library

    Copyright 1983,1984,1985,1986,1987,1988,1989,1990,1991,1992,1993,1994
		    Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/
#ifndef _CTYPE_H
#define _CTYPE_H
#ifdef __cplusplus
extern "C" {
#endif
#if defined(__STDC__) || defined(__PROTOTYPES__)
int isalnum(int);
int isalpha(int);
int iscntrl(int);
int isdigit(int);
int isgraph(int);
int islower(int);
int isprint(int);
int ispunct(int);
int isspace(int);
int isupper(int);
int isxdigit(int);
int tolower(int);
int toupper(int);
#if defined(__sysv) && defined(__unix)
/* [JY] Wed Oct  6 10:07:23 PDT 1993.  changed void return type to int */
int setchrclass(char *p);
#endif
#endif

#define _UPPER		0x01
#define _LOWER		0x02
#define _DIGIT		0x04
#define _SPACE		0x08
#define _PUNCT		0x10
#define _CONTROL	0x20
#if defined(__sysv) || !defined(__unix)
#define _BLANK		0x40
#define _HEXDIGIT	0x80
#else
#define _HEXDIGIT	0x40
#define _BLANK		0x80
#endif

#if defined(__m88k) && defined(__sysv) && !defined(__sysv40)
#define __CTYPE __ctype
#elif defined(__sun) || defined(__bsd)
#define __CTYPE _ctype_
#else
#define __CTYPE _ctype
#endif

extern unsigned char __CTYPE[];

/* These macros make incorrect code work correctly when the 8th bit is set
    and a signed char pointer is used.  See validate/c/lib/tctype.c  */

#define ____ctypeof(c) ((__CTYPE+1)[(sizeof(c)==1)?((unsigned char)(c)):(c)])

#define isalnum(ch) (____ctypeof(ch)&(_UPPER|_LOWER|_DIGIT))
#define isalpha(ch) (____ctypeof(ch)&(_UPPER|_LOWER))
#define iscntrl(ch) (____ctypeof(ch)&(_CONTROL))
#define isdigit(ch) (____ctypeof(ch)&(_DIGIT))
#define isgraph(ch) (____ctypeof(ch)&(_UPPER|_LOWER|_DIGIT|_PUNCT))
#define isprint(ch) (____ctypeof(ch)&(_UPPER|_LOWER|_DIGIT|_PUNCT|_BLANK))
#define islower(ch) (____ctypeof(ch)&(_LOWER))
#define ispunct(ch) (____ctypeof(ch)&(_PUNCT))
#define isspace(ch) (____ctypeof(ch)&(_SPACE))
#define isupper(ch) (____ctypeof(ch)&(_UPPER))
#define isxdigit(ch) (____ctypeof(ch)&(_DIGIT|_HEXDIGIT))

#define tolower(ch) tolower((sizeof(ch)==1)?((unsigned char)(ch)):(ch))
#define toupper(ch) toupper((sizeof(ch)==1)?((unsigned char)(ch)):(ch))

#if __STDC__==0 && !defined(_POSIX_SOURCE) 	/* old macros not in Ansi */
#define isascii(ch) ((unsigned)(ch)<=0x7f)
#define toascii(ch) ((ch)&0x7f)
#define iscntl(ch)  (iscntrl(ch))
#define _tolower(ch) (isupper(ch)?(ch)-'A'+'a':(ch))
#define _toupper(ch) (islower(ch)?(ch)-'a'+'A':(ch))
#define _isprint(ch) (isprint(ch))
#endif
#ifdef __cplusplus
}
#endif
#endif	/* _CTYPE_H */
