/***********************************************************************
<t@C>	flashlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		tbV֌W̃Cu
***********************************************************************/

#ifndef	_FLASHLIB_H_INCLUDED
#define	_FLASHLIB_H_INCLUDED

#include	<ioercode.h>

#pragma	H2EQU_INCLUDE	"ioercode.seq"

/***********************************************************************
  ^錾
***********************************************************************/

typedef long	ERRCODE;		/* ==0 : no error  ,  <0 : error */

/* rL^֎~̃[h */
#define	FLASH_SEMAPHORE_ENABLE	0x00	/* rL[h */
#define	FLASH_SEMAPHORE_DISABLE	0x01	/* r֎~[h */

/* foCXԍ */
typedef	UCHAR	FL_DRIVENO;

#define MAIN_FLASH		0x00	/* {̑̃tbV */
#define CARD_FLASH		0x01	/* J[h̃tbV */

/* hnbrɗv郂[h */
typedef	UCHAR	REQUEST_MODE;	/* x */

#define	FLASH_READ_LOCK			0x00	/* ǂ݂pɂknbj */
#define	FLASH_WRITE_LOCK		0x01	/* ݗpɂknbj */
#define	FLASH_IOCS_LOCK			0x02	/* hnbrpɂknbj */
#define	FLASH_READ_UNLOCK		0x10	/* ǂ݂knbj̉ */
#define	FLASH_WRITE_UNLOCK		0x11	/* ݂knbj̉ */
#define	FLASH_IOCS_UNLOCK		0x12	/* hnbrpknbj̉ */

/* tbVւ̏݋^֎~̐ */
typedef	UCHAR	WEWP_CTRL;

#define	WEWP_ENABLE		0x00		/* ݋֎~ɂ */
#define WEWP_DISABLE	0x01		/* ݉\Ԃɂ */
#define WE_ENABLE		0x02		/* ݋֎~ɂ */
#define WE_DISABLE		0x03	    /* ݉\ԂɂBAknbj͗L */

/* tbVԃ`FbNŒǉG[R[h */
typedef	UCHAR	FL_CONDITION;

#define FLASH_NORMAL			0x00	/* f[^ */
#define	FLASH_UNFORMAT			0x01	/* tH[}bgĂȂ */
#define	FLASH_DATA_ERROR		0x02	/* f[^j󂳂Ă */
#define FLASH_NO_DEVICE			0x03	/* tbV݂Ȃ */
#define FLASH_WRITE_PROTECT		0x04	/* ݋֎~rvLɂȂĂ */
#define FLASH_DISABLE_BY_USER	0x05	/* [U[ɂĎgp֎~ɂȂĂ */

/***********************************************************************
  tbV֌W̒萔
***********************************************************************/

#define	FLASH_DEV_CLUSTER_SIZE	0x1000	/* PNX^̃TCY */
#define FLASH_DEV_HALF_CLUSTER_SIZE	0x800

/***********************************************************************
  tbVJ[h
***********************************************************************/

#define	CARDTYPE_FLASHCARD	'FLSH'

/***********************************************************************
  hnbrt@NVԍ
***********************************************************************/

#define	FLASH_ACTIVATE			0x3d
#define	FLASH_FORMAT			0x3f
#define	FLASH_INIT				0x40
#define	FLASH_CARD_INIT			0x41
#define	FLASH_DEVICE_LOCK		0x42
#define	FLASH_PAGE_CLEAR	   	0x43
#define	FLASH_BYTE_WRITE   		0x44
#define	FLASH_BLOCK_WRITE		0x45
#define	FLASH_VOLTAGE_ON		0x46
#define	FLASH_VOLTAGE_OFF		0x47
#define	FLASH_DEV_INFO_READ		0x48
#define	FLASH_DEV_READ_MODE	   	0x49
#define	FLASH_DEV_ERASE			0x4a
#define	FLASH_DEV_ERASE_CHECK	0x4b
#define	FLASH_DEV_ALL_LOCK		0x4c
#define	FLASH_DEV_LOCK			0x4d
#define	FLASH_CTRL_WE_WP		0x4e
#define	FLASH_CHECK				0x4f
#define	FLASH_DEFAULT_FREE		0x50
#define	FLASH_DISABLE_DRIVE		0x51
#define	FLASH_ENABLE_DRIVE		0x52
#define	FLASH_INFO_READ_1M		0x53
#define	FLASH_BLOCK_WRITE_1M   	0x54
#define	FLASH_CHIP_ERASE_1M		0x55
#define	FLASH_CHIP_ERASE_PRE_1M	0x56
#define	FLASH_CHECK_ERASE_1M	0x57

/***********************************************************************
  tbVt@CVXěŗLG[R[h
***********************************************************************/

#define	FH_ERASE_ERROR			FLASH_EC_BASE+0x40	/* dq`rd̃G[ */
#define FH_VPP_ERROR			FLASH_EC_BASE+0x41	/* dxُ */
#define FH_LOW_BATTERY_ERROR	FLASH_EC_BASE+0x42	/* Write/Erase  caution x */
#define FH_IOCS_INIT_ERROR		FLASH_EC_BASE+0x43	/* hnbȑɃG[ */
#define	FH_IOCS_FORMAT_ERROR	FLASH_EC_BASE+0x44	/* tbṼtH[}bgG[ */
#define	FH_OPEN_ERROR			FLASH_EC_BASE+0x45	/* nodmłȂt@Cł */
#define	FH_LOCKED_ERROR			FLASH_EC_BASE+0x46	/* Write/Erase ubNbNĂ */
#define	FH_ABORTED_ERROR		FLASH_EC_BASE+0x47	/* ɃA{[gR}hsꂽ */
#define	FH_DEVICE_ERROR			FLASH_EC_BASE+0x48	/* foCXُ */
#define	FH_SYSTEM_ERROR			FLASH_EC_BASE+0x49	/* VXeǗُ */
#define	FH_MAX_FILE_OVER_ERROR 	FLASH_EC_BASE+0x4a	/* őt@CzĂ */
#define FH_WRITE_ERROR			FLASH_EC_BASE+0x4c	/* foCXُigCHj */
#define FH_DEV_ABORT_ERROR		FLASH_EC_BASE+0xfe	/* obJ[hñA{[g */

/***********************************************************************
  ֐vg^Cv錾
***********************************************************************/

ERRCODE FlashFileFormat(FL_DRIVENO);
/* void FlashInit(USHORT); */
void FlashCardInit(USHORT);
void FlashDevReadLock(void);
void FlashDevReadUnLock(void);
ERRCODE FlashDevPageClear(FL_DRIVENO,void *);
ERRCODE FlashDevByteWrite(FL_DRIVENO,UCHAR,void *);
ERRCODE FlashDevBlockWrite(FL_DRIVENO,void *,void *,int);
ERRCODE FlashDevVoltageOn(FL_DRIVENO);
void FlashDevVoltageOff(FL_DRIVENO);
/* ERRCODE FlashDevInfoRead(void *); */
void FlashDevReadMode(void *);
void FlashDevErase(void *);
ERRCODE FlashDevEraseCheck(void *);
ERRCODE FlashDevLockAllBlock(void *);
ERRCODE FlashDevLockBlock(void *);
void FlashDevCtrlWEWP(WEWP_CTRL);
FL_CONDITION FlashDevCheck(FL_DRIVENO);
int FlashDevDefaultFree(FL_DRIVENO);
ERRCODE FlashDevDisableDrive(FL_DRIVENO);
ERRCODE FlashDevEnableDrive(FL_DRIVENO);

/* L̊֐́Ach`fpł */
BOOLEAN	FlashPageClear(void *);
BOOLEAN FlashBlockWrite(void *,int,void *);
void FlashDevClear(void *);
BOOLEAN	IsFlashDevCleared(void *);

BOOLEAN	FlashPageClearFor1M(void *);
BOOLEAN FlashBlockWriteFor1M(void *,int,void *);
void FlashDevClearFor1M(void *);
BOOLEAN	IsFlashDevClearedFor1M(void *);

#endif
