/***********************************************************************
<t@C>	offscrn.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
***********************************************************************/

#ifndef _offscreen
#define _offscreen

#include <zdrawlib.h>

#define	NEW_OFFSCRN					0x50
#define DISPOSE_OFFSCRN				0x51
#define GET_OFFSCRN_INFO			0x52
#define	GET_PIXMAP_ADR_OFFSCRN		0x53
#define	OFFSCRN_DRAW_POINT			0x54
#define OFFSCRN_DRAW_LINE			0x55
#define	OFFSCRN_FILL_RECTANGLE		0x56
#define OFFSCRN_MOVE_RECTANGLE		0x57
#define OFFSCRN_CLEAR_RECTANGLE		0x58
#define OFFSCRN_CLEAR_ALL			0x59
#define	OFFSCRN_SCROLL_DOWN			0x5a
#define OFFSCRN_SCROLL_UP			0x5b
#define OFFSCRN_DISP_ICON			0x5c
#define	OFFSCRN_DISP_CHARS			0x5d
#define OFFSCRN_DRAW_RECTANGLE		0x5e
#define	OFFSCRN_PUSH_REGION			0x5f
#define	OFFSCRN_POP_REGION			0x60
#define	OFFSCRN_MAKE_THUMBNAIL		0x61
#define	OFFSCRN_DITHER				0x62
#define	OFFSCRN_SCALE_RECT			0x63
#define	OFFSCRN_COPY_RECT			0x64
#define OFFSCRN_LAST_FUNC			OFFSCRN_COPY_RECT

typedef UCHAR MyCOLOR;
typedef MyCOLOR PixMap;

typedef struct OFFSCRNINFO{
	RECTANGLE rect;         /* Size of Offscreen(DotW)		*/
	USHORT    depth;        /* Depth of Color(24, 16, 8, 1)    	*/
	USHORT    QP;           /* 𑜓x : 2 or 1					*/
	/* po͂Pdot  QOpo quarter point \				*/
	UINT	  size;			/* 摜f[^̃TCY				*/
} OFFSCRNINFO;

typedef struct OFFSCREEN{
	OFFSCRNINFO  info;      /* Header of OffScreen 				*/
	PixMap		*image;     /* Pixmap of OffScreen 				*/
} OFFSCREEN;

#define	TABLE_OFFSET	0x80
#define TABLE_MAX		15

#define	VRAM_OFFSCREEN	(TABLE_OFFSET+TABLE_MAX-1)

typedef struct TABLE{
	WINDOWHD	id;         	/* OffScreen Handle 			*/
	OFFSCREEN	Offscrn;    	/* OffScreen 					*/
} TABLE;

/* Define Line Pattern */
#define JR_LINE		6
#define	PR_LINE		7
#define	ROAD		8
#define ROAD2		9

#ifndef H2EQU
#define LINELENGTH	(sizeof(USHORT)*8)
#define FILLLEN  	(sizeof(USHORT)*8)
#endif H2EQU

typedef struct LINE_PAT_STR {   
	LINEPAT LineShape;  /* DrawLine()̐` */
	DOTSIZE DotSize;    /* DrawLine()̓_̑傫 */
} LINE_PAT_STR;

typedef struct PAINT_PAT_STR {
	PAINTPAT    FillMode;   /* BoxPaint()̃tBp^[ */
	DOTSIZE     DotSize;    /* BoxPaint()̓_̑傫 */
} PAINT_PAT_STR;

typedef struct POP_SCALE_STR {
	UCHAR       DummyA;     /* gȂ */
	SCALEMODE   ScaleMode;  /* DispPop()̃XP[ */
} POP_SCALE_STR;

typedef union LCD_R4 {
    USHORT      	SJCode;     /* ItXN[Disp1CharȂ... */
	/* Disp1Char()̃VtgJISR[h         */
    USHORT      	Scroll;     /* ScrollUp(),ScrollDown()̃XN[ */
    LINE_PAT_STR	LinePatStr;
    PAINT_PAT_STR	PaintPatStr;
    POP_SCALE_STR	PopScaleStr;
    short       DistanceY;      /* BoxMove()̈ړY */
    ICONMODE    IconMode;       /* DispIcon()̃ACR[h */
} LCD_R4;

typedef union LCD_R6 {
    UCHAR       *str;
    ICONDATA    *Icon;
    BOOLEAN     ClearFlag;
} LCD_R6;

typedef union LCD_DX {
    USHORT      CharStep;   /* Ԋu */
    short       LineP;
    short       DistanceX;  /* BoxMove()̈ړX */
} LCD_DX;

typedef struct GC{
	CDSPMODE	DispMode;	/*	`惂[h(bl)			*/
	DOTSHAPE	DotShape;	/* 	_`(bh)				*/
	GCTABLESET	GCTableSet;	/*	e[uZbgԍ(always=NORM_GCTABLESET)*/
	SCALEMODE	ScaleMode;	/*	XP[[h(			*/
	COLOR		*Fg;		/*	tHAOhJ[(si)*/
	COLOR		*Bg;		/*	obNOhJ[(di)*/
	RECTANGLE	Mask;		/*	t[}XN(px+8-14)	*/
	POINT		sp;         /* EBhEW(px+0-2) */
	POINT		ep;         /* EBhEEW(px+4-6) */
	WINDOWHD	WindowHd;   /* DispPush̃EBhEnhH */
	int			StrLen;     /* f[^oCg(R7) */
    LCD_R4      LCDr4;      /* R4(2) */
    LCD_R6      LCDr6;      /* R6(4) */
    LCD_DX      LCDdx;      /* dx(2) */
} GC;

typedef struct GC_DATA{
	DOTSIZE		DotSize;
	LINEPAT		LineShape;
	PAINTPAT	FillMode;
	SCALEMODE	ScaleMode;
	ICONMODE	IconMode;
	BOOLEAN		ClearFlag;
	USHORT		CharStep;
	short		LineP;
} GC_DATA;

typedef enum DOTLABEL {
	DOT = 0,
	DOT2,
	RECT4,
	DOT4
} DOTLABEL;

typedef struct OFFSCRNRECT {
	WINDOWHD	osHandle;
	RECTANGLE	*rect;
} OFFSCRNRECT;

/* OffscreenCopyRectcopyModebit */
#define	OFS_COPY_CLEAR	0x01

/* Prototype Declaration 			*/
/* OffScreen Management Function 	*/
void InitTable(void);
WINDOWHD NewOffScrn(RECTANGLE*, USHORT, USHORT);
BOOLEAN  DisposeOffScrn(WINDOWHD);
BOOLEAN  GetOffScrnInfo(WINDOWHD, OFFSCRNINFO*);
PixMap  *GetPixMapAdrOffScrn(WINDOWHD);

WINDOWHD NewOffscreen(RECTANGLE*, USHORT, USHORT);
BOOLEAN  DisposeOffscreen(WINDOWHD);
BOOLEAN  GetOffscreenInfo(WINDOWHD, OFFSCRNINFO*);
PixMap  *GetPixMapAdrOffscreen(WINDOWHD);

WINDOWHD	OffScrnMakeThumbnail(WINDOWHD);
WINDOWHD	OffscreenMakeThumbnail(WINDOWHD);
BOOLEAN		OffScrnDither(WINDOWHD, WINDOWHD, int);
BOOLEAN	OffscreenScaleRect(OFFSCRNRECT *dst,OFFSCRNRECT *src);
BOOLEAN	OffscreenCopyRect(OFFSCRNRECT *dst,OFFSCRNRECT *src,
						  UINT copyMode,COLOR *clearColor);

WINDOWHD OffscreenMakeThumbnailEx(WINDOWHD osSrcHd, USHORT* ThumbSizeX, USHORT* ThumbSizeY);

/* Pixmap management Function*/
static void    SetColor(COLOR*, COLOR*);
static void    SetColor3(COLOR*, UCHAR, UCHAR, UCHAR);
static void    SetRed(COLOR*, UCHAR);
static void    SetGreen(COLOR*, UCHAR);
static void    SetBlue(COLOR*, UCHAR);
static UCHAR   GetRed(COLOR*);
static UCHAR   GetGreen(COLOR*);
static UCHAR   GetBlue(COLOR*);
BOOLEAN CheckColor(COLOR*, COLOR*, USHORT);
void 	XorColor(COLOR*, COLOR*, COLOR*);

WINDOWHD new_offscrn(RECTANGLE*, USHORT, USHORT);
BOOLEAN  dispose_offscrn(WINDOWHD);
BOOLEAN  get_offscrn_info(WINDOWHD, OFFSCRNINFO*);
PixMap  *get_pixmap_adr_offscrn(WINDOWHD);
BOOLEAN  draw_offscreen(WINDOWHD, RECTANGLE*, WINDOWHD, RECTANGLE*,
						long, long, long, long, long, long,
						CDSPMODE, COLOR*, COLOR*, COLOR*, RECTANGLE*);
BOOLEAN	set_pixmap(PixMap*, POINT*, COLOR*, COLOR*,
				   long, long, long, long, long, long,
				   COLOR*, OFFSCRNINFO*);
BOOLEAN	get_pixmap(PixMap*, POINT*, COLOR*, COLOR*,
				   long, long, long, long, long, long,
				   COLOR*, OFFSCRNINFO*);
BOOLEAN check_color(COLOR*, COLOR*, USHORT);

/* Drawing Function */
BOOLEAN offscrn_draw_point(WINDOWHD, GC*); 
BOOLEAN offscrn_draw_line(WINDOWHD, GC*);
BOOLEAN offscrn_draw_rectangle(WINDOWHD, GC*);
BOOLEAN offscrn_fill_rectangle(WINDOWHD, GC*);
BOOLEAN offscrn_clear_all(WINDOWHD, GC*);
BOOLEAN offscrn_clear_rectangle(WINDOWHD, GC*);
BOOLEAN offscrn_move_rectangle(WINDOWHD, GC*);
BOOLEAN offscrn_draw_pattern_line(WINDOWHD, GC*);
BOOLEAN offscrn_draw_circle(WINDOWHD, GC*);
BOOLEAN offscrn_push_region(WINDOWHD, GC*);
BOOLEAN offscrn_pop_region(WINDOWHD, GC*);
BOOLEAN offscrn_disp_chars(WINDOWHD, GC*);
BOOLEAN offscrn_disp_icon(WINDOWHD, GC*);

BOOLEAN offscrn_scroll_up(WINDOWHD, GC*);
BOOLEAN offscrn_scroll_down(WINDOWHD, GC*);

BOOLEAN offscrn_draw_bitmap(OFFSCREEN*, POINT*, CDSPMODE, UCHAR*,
							BOOLEAN, int, int, COLOR*, COLOR*, RECTANGLE*);
BOOLEAN offscrn_draw_one_point(OFFSCREEN*, POINT*, CDSPMODE, COLOR*, COLOR*,
							   BOOLEAN, RECTANGLE*);
BOOLEAN offscrn_disp_one_char(WINDOWHD, GC*, USHORT, POINT*);

#endif
