/***************************************************************/
/***************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _POPH_
#define _POPH_

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#define	PLUS_TKN 		'+'
#define	PERIOD_TKN 	    '.'
#define	MINUS_TKN 	    '-'
#define	STAT_CMD		"STAT"
#define	QUIT_CMD		"QUIT"
#define	TOP_CMD			"TOP "
#define	LIST_CMD		"LIST"
#define	DELE_CMD		"DELE"
#define	RSET_CMD		"RSET"
#define	RETR_CMD		"RETR"


#define MAX_MSG_NUM		100


#define	POSITIVE				0	/* Positive response (+OK) */
#define NEGATIVE				1	/* Negative response (-ERR) */
#define INVALID					2	/* Invalid respnse (?) */


/* DO NOT CHAGE THE ORDER OF STATUS DEFINITIONS */

#define NO_CHAR		0	/* This block is first block to be sent */
#define NO_CR_LF	1	/* Last character is not neither cr nor lf */
						/* > 1 : States the characters are buffered in pop */
#define	IS_CR		2	/* Last character is cr (no lf) */
#define IS_EOL		3	/* Last character is EndOfLine */
#define IS_PERIOD	4	/* Received period token at the beginning of line
						   Pending store this character	*/
#define AWAIT_EOM	5	/* Received \r and waiting \n at the end of message */



#define RSP_INTERMIDIATE	1
#define RSP_DONE			0

#define	Pop3RsetCmd()	Pop3Cmd( RSET_CMD, NULL, NULL)

typedef struct	Pop3MsgInfo
{
	int 	MsgNumber;
	int 	MsgSize;
	int		MsgState;
	int	Count;
} POP3MSGINFO;




/* For debug porpose only */
#ifdef Debug
extern char MULTILINE[];
extern char OKRESP[];
extern char EOM[];
extern char STATRESP[];
extern char L1[];
extern char L2[];
extern char L3[];
extern char L4[];
extern char L5[];
extern int DebugCount;
extern char LISTRESP[];

extern char *DefaultResp;
extern char *DebugResp;
extern char *POP3OK;
#endif


/* Externals */
extern int Pop3FusionSocketErrp;
extern char Pop3Resp[];

#ifdef errp
  #undef errp
  #define errp	Pop3FusionSocketErrp
#endif


/* Function proto-type */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
int  MsgOut (char * szString1, char * szString2, char * szString3);
int  getLine ( char *outStr, int outStrSize);
/* boolean getWord(void); */

int  GetRepStatus ( char * string);
int  Pop3Cmd (char *cmd, char *opt, char *subopt);

int  Pop3QuitCmd(void);
int  Pop3DeleCmd (POP3MSGINFO *MsgInfoLst);
int Pop3StatCmd (void);

int  InitPop3Socket(void); 
void CleanupPop3Socket(void);
void ClosePop3Connection(void);
int  Pop3CallHost (char *node, char *user, char *pass, int *neterr);
int Pop3Login(char *user, char *pass, int *neterr);

/* int GetMultiLineResponse(char *MsgBuf, int Bytes, boolean *Done); Change 98.03.11*/
int GetMultiLineResponse(char *MsgBuf, int Bytes, BOOLEAN *Done);
int  Pop3GetHeader ( POP3MSGINFO *MsgInfoLst, char *MsgHeader, int Bytes, \
					 int NumberOfLines, int *GotBytes, int *neterr );
int  Pop3GetMessage ( POP3MSGINFO *MsgInfoLst, char *Message, int Bytes, \
					 int *GotBytes);
int  Pop3GetList ( POP3MSGINFO MsgInfoLst[], int lNumberOfMsgs );
/*int GetMessageList ( POP3MSGINFO *MsgInfoLst, int lNumberOfMsgs ); */

#ifdef  __cplusplus				/* C++ support  99/9/10*/
void InitPop3 (  char * rbuf, int rsize, char * wbuf, int wsize, 
				char * respbuf, int respsize, int(*abort)(...) );
#else
void InitPop3 (  char * rbuf, int rsize, char * wbuf, int wsize, 
				char * respbuf, int respsize, int(*abort)() );
#endif
END_EXTERN_C                /* C++ support  99/9/8 */
/* End of pop.h */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _POPH_ */
