/*******************************************************************************

<rslproc.h>


*******************************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _RSLPROCH_
#define _RSLPROCH_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/* Message Queue */
#define RSLQNOMSG           0                       /* L[ɃbZ[WȂ */
#define RSLQERROR           -1                      /* G[  */
#define RSLQTIMEOUT         -2                      /* ^CAEg */

/* Message Type */
#define INIT_DNS_REQ        0x80                    /* vbZ[W */ 
#define ADD_DNS_REQ         0x81                    /* DNST[o̓o^vbZ[W */
#define DEL_DNS_REQ         0x82                    /* DNST[o̍폜vbZ[W */
#define CONFIG_DNS_REQ      0x83                    /* ݒvbZ[W */
#define QRY_REQ             0x84                    /* ₢킹vbZ[W */
#define CLEAR_DNS_REQ       0x85                    /* [vbZ[W */
#define INIT_DNS_RSP        0x00                    /* bZ[W */ 
#define ADD_DNS_RSP         0x01                    /* DNST[o̓o^bZ[W */
#define DEL_DNS_RSP         0x02                    /* DNST[o̍폜bZ[W */
#define CONFIG_DNS_RSP      0x03                    /* ݒ艞bZ[W */
#define QRY_RSP             0x04                    /* ₢킹bZ[W */
#define CLEAR_DNS_RSP       0x05                    /* [bZ[W */

/* Result  */
#define RESULT_OK           0x80                    /* vꂽ̐ */ 
#define RESULT_NG           0x00                    /* vꂽ̎s */

/* Error */
#define RESOLVER_OK         0                  /*  */ 
#define INVALID_SEARCH      1                  /* IPAhXAhC */
#define NO_DNS_ENTRY        2                  /* DNST[oo^ĂȂ */
#define HOST_NOT_FOUND      3                  /* DNST[ỏȂ */
#define NO_RECOVERY         4                  /* vIG[ (mۂłȂ) */
#define NO_DATA             5                  /* f[^o^ĂȂ */
#define TOO_LONG_DNAME      6                  /* g̃hCz */
#define TOO_LONG_QUERY      7                  /* ₢킹̃pPbgTCY */
#define SOCKET_FAIL         8                  /* \Pbg֘ÃG[ (open, sendto, nselect, recv) */
#define RECV_DATA_ILLEGAL   9                  /* Mf[^ɏłȂ */

/* vbZ[W */
struct init
        {
	    int retry;                              /* gC */
	    int interval;                           /* gp */
	    unsigned char vc[4];                    /* ڑ^Cv */
	    unsigned char domain_suffix[256];       /* hCTtBbNX */
	};

struct config
        {
	    int newsize;                            /* ύXLbVTCYl */
	    int retry;                              /* gp */
	    int interval;                           /* gp */
	};

struct qryr
        {
	    unsigned int rr_type;                   /* \[XR[h̃^Cv */
	    unsigned char name[256];                /* hCAIPAhX */
	};

struct RslRequestMsg
        {
	    unsigned char messageType;              /* bZ[W^Cv */  
	    unsigned char requestID;                /* gp */
	    OBJECT_NAME resultQueue;                /* bZ[WރbZ[WL[ */
	    OBJECT_NAME resultProcess;              /* bZ[WMvZX */
	    union { struct init init;               /* vbZ[W */
		    unsigned char DNS_server[256];  /* DNST[o̓o^^폜vbZ[W */ 
		    struct config config;           /* ݒvbZ[W */
		    struct qryr qryr;               /* ₢킹vbZ[W */
	    } reqdata; 
	};

/* bZ[W */
struct RslAnswerMsg
        {
	    unsigned char messageType;              /* bZ[W^Cv */                         
	    unsigned char requestID;                /* gp */
	    unsigned char result;                   /*  */
	    OBJECT_NAME resultProcess;              /* bZ[WMvZX */
	    unsigned long rslinfop;                 /* ]o\̂ւ̃|C^ */
	}; 

/* Function Command */
#define RESOLVER_INIT_REQ      0                    /* v */
#define RESOLVER_CLEAR_REQ     1                    /* [v */
#define ADD_DNSSERVER_REQ      2                    /* DNST[oo^v */ 
#define DELETE_DNSSERVER_REQ   3                    /* DNST[o폜v */
#define SET_CACHESIZE_REQ      4                    /* ݒv */
#define RESOLVE_A_REQ          5                    /* AR[hł̖₢킹v */
#define RESOLVE_PTR_REQ        6                    /* PTRR[hł̖₢킹v */
#define RESOLVE_MX_REQ         7                    /* MXR[hł̖₢킹v */
#define SEARCH_A               8                    /* AR[ȟʎ擾 */
#define SEARCH_PTR             9                    /* PTRR[ȟʎ擾 */
#define SEARCH_MX             10                    /* MXR[ȟʎ擾 */

/* gbvp[^ */
struct rsltrap
        {
	    int cmd;                                /* Function Command */
	    long p1;                                /* Pp[^ */
	    long p2;                                /* Qp[^ */
	    long p3;                                /* Rp[^ */
	    long p4;                                /* Sp[^ */
	    long p5;                                /* Tp[^ */
	    long resp;                              /*  */
	};

/* DNSAPI Function */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
void rsl_applfunc( struct rsltrap *rsl_trap );

/* Resolver Process Dummy */
void resolver_proc( void );

/* Resolver Process Main */
void rsl_proc_main( int dummy1, int dummy2, int dummy3 );
END_EXTERN_C                /* C++ support  99/9/8 */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _RSLPROCH_ */
