/***********************************************************************
<t@C>	sfconv.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef _SFCONV_H
#define _SFCONV_H
/* for gcc, ROM area is defined as constant */
#define ROM	const

/* PRIVATE VARIABLES */
#define EPSILON 3L	/* Q15 small margin of Q15 coparison */

typedef struct {
  ulong	step;	/* Q15 float index increment unit (LONG!) */
  long	pos;	/* Q15 float index on din[] (LONG!)*/
  short	last;	/* Q0  last sample of recent read */
} DWN_PARA;

/* TABLES */
#define  ORDER		6
#define  NUM_LPF	10

/* PRIVATE VARIABLES */
typedef struct {
  short *den;		/* Q11 denominator coefficients */
  short *num;		/* Q15 numerator coefficients */
  short regi[ORDER+1];	/* Q0  wave sample */
  short rego[ORDER+1];	/* Q0  wave sample */
  short gain;		/* Q0 integer gain */
} LPF_PARA;

/* TABLES for CONV */
#define NUM_SF		11
#define NUM_CONV	26

/* PRIVATE VARIABLES */
typedef struct {
  int	conv_type;	/* 0 - (NUM_CONV-1) */
  ulong	fs_med;		/* medium data frequency */
  int	up_rate;	/* up-sample ratio */
  int	lpf_type;	/* 0 - (NUM_LPF-1) */
  DWN_PARA dwn;
  LPF_PARA lpf;
  short  *buff1;	/* work, upsampled data */
  short  *buff2;	/* work, upsampled and low-passed data */
} CNV_PARA;
#endif	/* _SFCONV_H	*/
