/*
		      ANSI C Runtime Library

	Copyright 1983-1995 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef _STDDEF_H
#define _STDDEF_H
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__cplusplus) && !defined(NULL)
#define NULL 0L		/* C++ requires this to be integral, not a pointer */
#elif !defined(NULL)
#define NULL ((void *)0)/* locale.h stddef.h stdio.h stdlib.h string.h time.h */
#endif

#ifndef _PTRDIFF_T
#define _PTRDIFF_T
# if !defined(__Ptr_Is_64) || defined(__Int_Is_64)
typedef int ptrdiff_t;
# else
typedef long ptrdiff_t;
# endif
#endif	/* _PTRDIFF_T */
#ifndef _SIZE_T
#define _SIZE_T
# if defined(__Ptr_Is_64) && !defined(__Int_Is_64)
typedef unsigned long size_t;
# else
typedef unsigned int size_t;
# endif
#endif	/* _SIZE_T */
#ifndef _WCHAR_T
#define _WCHAR_T
	typedef 
# ifdef __WChar_Is_Unsigned__
		unsigned 
# endif
# ifdef __WChar_Is_Short__
			short
# elif __WChar_Is_Int__
			int
# else
			long 
# endif
				wchar_t;
#endif /* _WCHAR_T */

#ifdef __cplusplus
#define offsetof(t, memb) 	((size_t)__INTADDR__(&(((t *)0)->memb)))
/* #define offsetof(type,id)	((size_t)&(((type *)0)->id)) */
#else
#define offsetof(type,id)	(__offsetof(((type *) 1)->id))
#endif

#ifdef __cplusplus
}
#endif
#endif  /* _STDDEF_H */
