/***********************************************************************
<t@C>	zas.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
	Ver.2.0 for MI-500
***********************************************************************/

/***********************************************************************
		ZAS(Zaurus Application Service)`
***********************************************************************/
#ifndef ZAS_H_INCLUDED
#define	ZAS_H_INCLUDED
#include <sharpgen.h>
#ifndef H2EQU
#include <message.h>
#endif H2EQU
#include <zdam.h>
#include <cliplib.h>
#include <winlib.h>

/* t@NV̖߂l */
typedef enum ZASERR {
	ZAS_NO_ERR,
	ZAS_NOP_MSG,
	ZAS_FATAL_ERR,
	ZAS_PROTOCOL_ERR
} ZASERR;

/* t@NVԍ */
#define	REQ_APPLICATION_SERVICE		0x41
#define	ZAS_SELECT_FILE				0x42
#define	ZAS_ADD_DATA_TO_FILE		0x43
#define	REQ_MY_EXEC_SERVICE			0x44
#define	IS_MY_SERVICE_IN			0x45
#define	SET_MY_EXEC_SERVICE_ANSWER	0x46
#define	GET_SERVICE_ANSWER			0x47
#define	ZAS_SET_PARAMS				0x48
#define	ZAS_GET_PARAMS				0x49
#define	ZAS_COUNT_APL_DATA_IN_FILE	0x4a
#define	ZAS_GET_SEARCH_INFO			0x4b
#define	ZAS_GET_DTM_SER_COND		0x4c
#define	ZAS_GET_START_DATA_TYPE		0x4d
#define	ZAS_SETUP_FOR_DTM			0x4e
#define	ZAS_COUNT_ANSWER			0x4f
#define	ZAS_SEARCH_ANSWER			0x50
#define	ZAS_GET_DISP_INFO			0x51
#define	ZAS_ADD_POST_IT				0x52
#define	ZAS_ADD_POST_IT_TO_DATA		0x53
#define	ZAS_DISP_POST_IT			0x54
#define	ZAS_DELETE_POST_IT			0x55
#define	WRITE_OPEN_ZEX				0x56
#define	APPEND_ZEX_RECORD			0x57
#define	WRITE_CLOSE_ZEX				0x58
#define	SET_ZEX_APL_NAME			0x59
#define	APPEND_ZEX_DTM_ITEM_REC		0x5a
#define	READ_OPEN_ZEX				0x5b
#define	READ_CLOSE_ZEX				0x5c
#define	GET_NEXT_ZEX_RECORD			0x5d
#define	GET_ZEX_DTM_ITEM_REC		0x5e
#define	ZAS_SEARCH_APL_DATA_IN_FILE	0x5f
#define	ZAS_REQ_SEARCH_SERV			0x60
#define	ZAS_REQ_CTGR_METHOD_SERV	0x61
#define	ZAS_CTGR_METHOD_SERV		0x62
#define	ZAS_GET_POST_IT				0x63
#define	ZAS_COUNT_POST_IT			0x64
#define	ZAS_SEARCH_APL_POST_IT		0x65
#define	IS_APL_POST_IT_EXIST		0x66
#define	ZAS_ENCLOSE_MAIL			0x67
#define	ZAS_GET_DATA_INFO			0x68
#define	ZAS_CHANGE_ITEM				0x69
#define	ZAS_GET_CHANGE_ITEM			0x6a
#define	ZAS_ENCLOSE_NEW_MAIL		0x6b
#define	ZAS_REQ_SER_ADD_CTGR_SERV	0x6c
#define	ZAS_GET_SER_ADD_CTGR_INFO	0x6d
#define	ZAS_COUNT_RESULT_ANSWER		0x6e
#define	ZAS_GET_C_R_ANSWER			0x6f
#define	ZAS_REQ_CAMERA_SERVICE		0x70
#define	ZAS_GET_CAMERA_RESULT		0x71
#define	ZAS_IS_CATEGORY_COUNT		0x72

#define	ZAS_LAST_FUNC	ZAS_IS_CATEGORY_COUNT


#ifndef H2EQU
/* VXeK̃T[rXID */
#define	ZAS_UPDATE_ID			1	/* ]AppliUpdateIDɑ */
#define	ZAS_WRITE_DATA_ID		2	/* f[^o^ */
#define	ZAS_DISP_DATA_ID		3	/* f[^\ */
#define	ZAS_SEARCH_DATA_ID		4	/* f[^ */
#define	ZAS_DELETE_DATA_ID		5	/* f[^폜 */
#define	ZAS_GET_INFO_ID			6	/* Av擾 */
#define	ZAS_ENCLOSE_MAIL_ID		7	/* [ւ̓Yt */
#define	ZAS_ADD_POST_IT_ID		8	/* PostIto^ - PostItf[^I[i */
#define	ZAS_DISP_POST_IT_ID		9	/* PostIt\ - PostItf[^I[i*/
#define	ZAS_DELETE_POST_IT_ID	10	/* PostItO - PostItf[^\ */
#define	ZAS_GROUP_DATA_ID		11	/* i荞݃f[^\ */
#define	ZAS_CTGR_METHOD_ID		12	/* JeS[ */
#define	ZAS_GET_DATA_ID			13	/* f[^擾 */
#define	ZAS_SET_CRNT_DATA_ID	14	/* ڃf[^̃Zbg */
#define	ZAS_OPEN_FILE_ID		15	/* t@CI[v */
#define	ZAS_CLOSE_FILE_ID		16	/* t@CN[Y */
#define	ZAS_DELETE_SECRET_ID	17	/* V[Nbgf[^폜 */
#define	ZAS_EMBED_IN_ID			18	/* ߍݕ\[hJn */
#define	ZAS_EMBED_OUT_ID		19	/* ߍݕ\[hI */
#define	ZAS_OPTION_ID			20	/* IvVT[rX */
#define	ZAS_CHECK_FILE_ID		21	/* t@C`FbNT[rX */
#define	ZAS_GET_CRNT_DATA_ID	22	/* ڃf[^𓾂 */
#define	ZAS_ENCLOSE_FAX_ID		23	/* FAXMT[rX */
#define	ZAS_CHANGE_ITEM_ID		24	/* Pڃf[^uT[rX */
#define ZAS_SEARCH_AND_ADD_CTGR_ID	25	/* f[^JeS[ǉ */

/* ԓpT[rXID */
#define	ZAS_CANCEL_ID			0	/* ԓLZ */
#define	ZAS_SERV_START_S_ID		90	/* 풓[hŃT[rXJn */
#define	ZAS_SERV_START_N_ID		91	/* ʏ탂[hŃT[rXJn */

/* AvP[VƎ̃T[rXID(ROMAv̂) */
#define	ZAS_CLCK_NAME			'CLCK'
#define	ZAS_CLCK_SET_ID			100

#define	ZAS_FLER_NAME			'FLER'
#define	ZAS_FLER_SELECT_FILE_ID	100

#define	ZAS_LNCH_NAME			'LNCH'
#define	ZAS_LNCH_DSP_STAT_ID	100

#define	ZAS_CAMERA_NAME			'CAMC'
#define	ZAS_CAMERA_ID			100

/* AvP[V(256 -) */
/* XPW[ */
#define	SCDL_DAILY_PLAN_EXEC	0x0100
#define	SCDL_TODO_EXEC			0x0200
#define	SCDL_SCHEDULE_EXEC		0x0300
#define	SCDL_AFTER_ALRM_EXEC	0x0400

/* tHg[ */
#define	PANT_FAX_VIEW_EXEC		0x0100
#define	PANT_PAINT_EXEC			0x0200

/* t@C */
#define	FLER_ACT_PLAN_EXEC		0x0100
#define	FLER_FILER_EXEC			0x0200
#define	FLER_FAX_EXEC			0x0300

/* [ */
#define	MAIL_SEND_EXEC			0x0100
#define	MAIL_RECV_EXEC			0x0200
#define	MAIL_FAX_SEND_EXEC		0x0300
#define	MAIL_FAX_RECV_EXEC		0x0400
#define	MAIL_INBOX_EXEC			0x0500

/* ZNET */
#define	ZNET_BBS_EXEC			0x0100
#define	ZNET_NIF_EXEC			0x0200
#define	ZNET_TELNET_CON_EXEC	0x0300
#define	ZNET_TELNET_LOG_EXEC	0x0400

/* Internet */
#define	ZWWW_NORM_EXEC			0x0100
#define	ZWWW_TELNET_EXEC		0x0200
#define	ZWWW_TELNET_ILL_EXEC	0x0300
#define	ZWWW_LIST_EXEC			0x0400


/* ReqApplicationService()̓ΏۃAvw */
#define	ZAS_REQ_ALL_APL			0	/* SẴAv */

/* ZASf[^pNbv{[hԍ` */
#define	ZAS_DATA_BOARD_NO	CP_APL_IAC_BUF
#define	ZAS_CTRL_BOARD_NO	CP_APL_IAC_CTL_BUF
#define	ZAS_DATA_BOARD_NAME	(UCHAR*)"ZASD"
#define	ZAS_CTRL_BOARD_NAME	(UCHAR*)"ZASC"

/* PRs[f[^p */
#define	ZEX_ONE_DATA_NAME	(UCHAR*)"ZITM"	/* ZEX` */
#define	DBZ_ONE_DATA_NAME	(UCHAR*)"ITMS"	/* ` */

/* JeS[p[^ */
#define	ZC_ADD_CTGR			1	/* JeS[ǉ */
#define	ZC_DEL_CTGR			2	/* JeS[폜 */
#define	ZC_MOV_CTGR			3	/* JeS[ړ */

/* f[^擾p[^ */
#define	ZG_BY_ZEX			1	/* ZEX`Ŏo */
#define	ZG_BY_TEXT			2	/* eLXgŎo */

/* p[^ */
#define	ZS_P_SEARCH			1	/* Yf[^Ԃ */
#define	ZS_P_COUNT			2	/* Yf[^Ԃ */

/* YNԖڂ̃f[^T */
/* 0	:	擪(Jnf[^͖)  */
/* 1-	:	NԖ */

/* @ */
#define	ZS_KEYWORD_SEARCH	1	/* Yf[^L[[h */
								/* (͑ŠƓ) */
#define	ZS_DTM_SEARCH		2	/* DTM */
#define	ZS_LINK_SEARCH		3	/* Nf[^ */

/* f[^w */
typedef struct ZAS_DTM {
	USHORT		DataNo;			/* J[hID or CfbNXԍ */
	DTMFNAME	DTMFile;		/* BOXt@C or INDEXt@C */
} ZAS_DTM;

typedef union ZAS_DATA_SCRIPT {
	ZAS_DATA_NO	ZASData;	/* ZAS^f[^w` */
	ZAS_DTM		DTMData;	/* DTMf[^w` */
} ZAS_DATA_SCRIPT;

typedef struct ZAS_TARGET_DATA {
	DATAPATH		Form;			/* ` */
	ZAS_DATA_SCRIPT	Data;
} ZAS_TARGET_DATA;

/*  - ZASRg[obt@ɏ */
typedef struct ZAS_SEARCH_INFO {
	USHORT			SearchMode;		/* @ */
	UCHAR			Direction;		/*  */
	DATAPATH		ResultPath;		/* ʎn@ */
	UCHAR			VolumeNo;		/* {[ԍ */
	USHORT			Number;			/* ԖڂTH */
	ZAS_TARGET_DATA	StartData;		/* Jnf[^ */
} ZAS_SEARCH_INFO;

typedef struct ZAS_DTM_INFO {
	INDEXNO			StartIndexNo;
	UCHAR			Direction;
	UCHAR			AttrMask;
	UCHAR			AttrCond;
	UCHAR			AttrFlag;
} ZAS_DTM_INFO;

#define	ZAS_MAX_SER_COND	100	/* Ƃ肠̂炢 */

/* ZASf[^\ */
/* eLXg\` */
typedef struct DISP_INFO {
	RECTANGLE	TextRect;		/* eLXg\̈` */
	RECTANGLE	RawRect;		/* \̈S̋` */
	RECTANGLE	MaskRect;		/* }XN̈` */
	UPOINT		DispLineOffset;	/* \Jns */
	POINT		RawOffset;		/* C[W\ItZbg */
	CDSPMODE	DspMode;		/* \[h */
	UCHAR		CharPitch;		/* ԃsb` */
	UCHAR		LinePitch;		/* sԃsb` */
	COLOR		Fg;				/* tHAOEhJ[ */
	COLOR		Bg;				/* obNOEhJ[ */
	UCHAR		Align;			/* \ʒuIvV */
} DISP_INFO;

/* \[h */
#define	ZAS_DISP_ONE_DATA	1
#define	ZAS_DISP_LIST		2

typedef struct ZAS_DISP_INFO {
	WINDOWHD		WnHandle;		/* `ΏۃEBhEnh */
	DATAPATH		DispDataPath;	/* \f[^̎n@ */
	USHORT			DispForm;		/* \[h */
	ZAS_TARGET_DATA	DispData;
	DISP_INFO		DispInfo;
} ZAS_DISP_INFO;

/* \ԓ */
typedef struct DISP_ANSWER {
	USHORT			DispType;		/* \^Cv */
	UPOINT			DispAllDataNo;	/* \TCY */
} DISP_ANSWER;

#define	ZAS_DISP_DONE		1
#define	ZAS_DISP_EMBED		2

/* JeS[ */

typedef struct ZAS_CTGR_INFO {
	ZAS_TARGET_DATA	TargetData;		/* Ώۂ̃f[^ */
	CATEGORYID		Category1;
	CATEGORYID		Category2;
} ZAS_CTGR_INFO;

/* IvVp[^ */
#define	ZAS_OPT_CABLE		1
#define	ZAS_OPT_IR			2
#define	ZAS_OPT_CARD		3
#define	ZAS_OPT_PRINTER		4
#define	ZAS_OPT_CARD_OCR	5
#define	ZAS_OPT_FAX			6

/* ZAS_SEARCH_AND_ADD_CTGR_IDp` */
#define SD_SER_NORMS	0x01
#define SD_SER_PRODS	0x02
#define SD_SER_TODO		0x04
#define SD_SER_ANV1		0x08
#define SD_SER_ANV2		0x10
#define SD_SER_CNTCT	0x11
#define SD_SER_ALLDATA	0xffffffff

#define SD_SER_ALL_DATA_NUM	0

#define ZC_RET_EXEC_CMP 	1	/* I */
#define ZC_RET_BREAK		2	/* Abort */
#define ZC_RET_UMEM_FULL	3	/* [U[[t */

/* &JeS[IDǉ - ZASRg[obt@ɏ */
typedef struct ZAS_SEARCH_AND_ADD_CTGR_INFO {
	ZAS_SEARCH_INFO	ZasSerInfo;		/* ZAS */
	ULONG			TargetDataType;	/* Ώۃf[^ */
	USHORT			DataNum;		/* ǉf[^ */
	CATEGORYID		CategoryID;		/* ǉJeS[ID */
	UCHAR			OperationID;	/* e */
} ZAS_SEARCH_AND_ADD_CTGR_INFO;

/* JT[rXp[^`(16bit) */
/* ftHglw */
/* Av؂ւ(bit11) */
#define ZCAM_PERMIT_APLSW	0x00000800
/* CEAG05 pBe[hftHgl(bit14-15) */
#define ZCAM_MODE_MASK	0x0000c000
#define ZCAM_AUTO_MODE	0x00000000
#define ZCAM_DOC_MODE	0x00004000
#define ZCAM_PORT_MODE	0x00008000
#define ZCAM_LAND_MODE	0x0000c000
/* OZASData`Ɠl̎wƂ */

/* JT[rXZASData`(zasBufgp - 8byte) */
/* ełI͈͂w */
/* 2oCg(bit0-15) */
/* 摜TCY(bit0-7) - bit4-7͗\ */
#define ZCAM_XGA		0x00000020	/* XGA(1024X768) */
#define ZCAM_SVGA		0x00000010	/* SVGA(800X600) */
#define	ZCAM_VGA		0x00000008	/* VGA(640X480) */
#define	ZCAM_4VGA		0x00000004	/* 1/4VGA(320X240) */
#define	ZCAM_16VGA		0x00000002	/* 1/16VGA(160X120) */
#define	ZCAM_64VGA		0x00000001	/* 1/64VGA(80X60) */
/* 掿(bit8-11) - bit8,11͗\ */
#define	ZCAM_QNORM		0x00000200	/* m[} */
#define	ZCAM_QFINE		0x00000400	/* t@C */
/* A(bit12-13) */
#define	ZCAM_AUTO_C		0x00001000	/* A */
#define	ZCAM_MAN_C		0x00002000	/* 蓮A(ʏ͕s) */
/* 摜tH[}bg1oCg(bit16-23)ɓ */
/* EBhEʒu1oCg(bit24-31)ɓ */
#define	ZCAM_WN_RESUME	0x80		/* EBhEʒuW[ */
/* EBhEʒuɊւĂwinlib.h̒`gI */
/* 摜őTCYŏ4oCgɓ */

typedef enum ZASIMGTYPE {
	ZAS_IMG_16BIT=1,
	ZAS_IMG_JPEG
} ZASIMGTYPE;

/* 摜f[^ñNbv{[hʖ */
#define	ZAS_CAMC_BOARD_NAME	(UCHAR*)"ZCAM"

/* ZAS_WRITE_DATA Ver.2param̃rbg` */
/* bit0:A[g\邩ǂ */
#define	ZASWD_ALERT_DISP	0x0001

/* bit1-3: o^{[̎w */
#define	ZASWD_MAIN_VOLUME	0x0002	/* {(Aṽ{[) */
#define	ZASWD_CARD_VOLUME	0x0004	/* J[h(̔) */
#define	ZASWD_CRNT_VOLUME	0x0006	/* ڃ{[ */
#define	ZASWD_ASK_VOLUME	0x0008	/* [Uɖ₢킹 */
#define	ZASWD_DEF_VOLUME	0x000a	/* Dȃ{[ */

#define	ZASWD_VOL_MASK		0x000e

/********* ȉ ZEXɊւ` **********/
/* ̓ACgɂ͏悹Ȃ̂ō\̒`͂łȂ */

/* wb_` */
#define	ZEX_HEADER_APLNAME		0
#define	ZEX_HEADER_DATA_TYPE	ZEX_HEADER_APLNAME+4

#define	ZEX_DATA_HEADER_LEN		(ZEX_HEADER_DATA_TYPE+1)

/* R[hwb_` */
#define	ZEX_RECORD_TAG			0
#define	ZEX_RECORD_LEN			(ZEX_RECORD_TAG+1)
#define	ZEX_RECORD_DATA			(ZEX_RECORD_LEN+4)
#define	ZEX_RECORD_HEAD_SIZE	ZEX_RECORD_DATA

/* f[^^Cv` */
#define	ZEX_VERSION1		1
#define	ZEX_TEXT			2

/* ^O`	   0 -   99 VXe\	*/
/*           100 -  255 ̓AvƎŒ`	*/
#define	ZEX_END_REC_TAG		0		/* IR[h */
#define	ZEX_DTM_ITEM_TAG	1		/* DTMڃR[h */
#define	ZEX_LINK_TEXT_TAG	2		/* p~ */
#define	ZEX_COMMENT_TAG		3		/* RgR[h */
#define	ZEX_ZAS_INFO_TAG	4		/* ZAS񃌃R[h - p~H */
#define	ZEX_APPLI_NAME_TAG	5		/* AvP[V */
#define	ZEX_LINK_INFO_TAG	6		/* N񃌃R[h */

/* Avő */
#define	MAX_APL_NAME		40

/* ZASp` */
#define	ZAS_IMMD_DISP		1	/* IMMEDIATE[h */
#define	ZAS_CMD_DISP		2	/* {^H */

/* ZEX_DTM_ITEM_TAG` */
#define	ZEX_D_DATA_ID		0
#define	ZEX_D_CONV_ID		(ZEX_D_DATA_ID+1)
#define	ZEX_D_ITEM_NAME		(ZEX_D_CONV_ID+1)
#define	ZEX_D_DATA			(ZEX_D_ITEM_NAME+4)
#define	ZEX_D_HEADER_SIZE	ZEX_D_DATA

/* ZEX_LINK_INFO_TAG` */
#define	ZEX_L_INFO_APLID	0
#define	ZEX_L_INFO_TEXT		(ZEX_L_INFO_APLID+4)

/* N^Cg */
#define	ZAS_LINK_TITLE_LEN		16
#define	ZAS_LINK_TITLE_BUF_LEN	(ZAS_LINK_TITLE_LEN+1)

#define	ZAS_L_INFO_MAX		(ZAS_LINK_TITLE_BUF_LEN+ZEX_RECORD_HEAD_SIZE+4)

/* Nő吔 */
#define	ZAS_L_INFO_ITEM_MAX	100

/* Ni[ɕKvȃobt@ */
#define	ZAS_L_INFO_MAX_BUF	(ZAS_L_INFO_ITEM_MAX*ZAS_L_INFO_MAX+	\
							 ZEX_DATA_HEADER_LEN+1)

#define	GetZEXRecTag(ptr)	(*(ptr+ZEX_RECORD_TAG))
#define	GetZEXRecLen(ptr)	(GetLFromBArray((ptr)+ZEX_RECORD_LEN))

/* ZEXzt@Cnh */
typedef struct ZEXFP {
	CLIPID	ClipNo;
	UCHAR	*ClipBuf;
	ULONG	Len;
} ZEXFP;

/* ֐` */

BOOLEAN ReqApplicationService(MESSAGE *Message,APLID DestAplName,
							  USHORT ServiceID,UCHAR Version);
ZASERR ZASSelectFile(MESSAGE *Message,UCHAR VolumeNo);
ZASERR ZASAddDataToFile(MESSAGE *Message,
						FILEINFO *FInfoPtr,CARDID CardID);
void ReqMyExecService(MESSAGE *Message,USHORT ServiceID,
					  UCHAR Version,BOOLEAN IsSticky);
BOOLEAN IsMyServiceIn(MESSAGE *Message);
void SetMyExecServiceAnswer(MESSAGE *Message,USHORT ServiceID,
							UCHAR Version);
BOOLEAN GetServiceAnswer(MESSAGE *Message,USHORT *ServiceID,
						 UCHAR *Version);
void ZASSetParams(MESSAGE *Message,
				  USHORT Param,DATAPATH DataPath,ZAS_DATA *ZASData);
void ZASGetParams(MESSAGE *Message,
				  USHORT *Param,DATAPATH *DataPath,ZAS_DATA *ZASData);
USHORT ZASCountAplDataInFile(MESSAGE *Message,APLID DestAplName,
							 CATEGORYID CategoryID,UCHAR VolumeNo);
BOOLEAN ZASGetSearchInfo(MESSAGE *Message,UCHAR *SerCond,USHORT *Len,
						 ZAS_SEARCH_INFO *ZASSerInfo);
void ZASGetDTMSerCond(UCHAR *SerCond,USHORT *Len,ZAS_SEARCH_INFO *ZASSerInfo);
BOOLEAN ZASGetStartDataType(ZAS_SEARCH_INFO *ZASSerInfo,UCHAR *DataType);
BOOLEAN ZASSetupForDTM(DTMFNAME *IndexFName,
					   ZAS_SEARCH_INFO *ZASSerInfo,
					   ZAS_DTM_INFO *ZASDTMInfo);
void ZASCountAnswer(MESSAGE *Message,USHORT CountResult);
void ZASSearchAnswer(MESSAGE *Message,ZAS_DATA_NO *ZASDataNo,
					 DATAPATH DataPath);
BOOLEAN ZASGetDispInfo(MESSAGE *Message,ZAS_DISP_INFO *ZASDispInfo);
BOOLEAN ZASAddPostIt(MESSAGE *Message,APLID DestAplName,UCHAR VolumeNo);
ZASERR ZASAddPostItToData(MESSAGE *Message,
						  FILEINFO *FInfoPtr,CARDID CardID);
BOOLEAN ZASDispPostIt(MESSAGE *Message,FILEINFO *FInfoPtr,
					  CARDID CardID,CBPROC *CallBackFunc,void *Work);
BOOLEAN WriteOpenZEX(CLIPID ClipNo,APLID AplName,CLIPNAME ClipName);
BOOLEAN AppendZEXRecord(CLIPID ClipNo,UCHAR *Record,ULONG RecLen);
BOOLEAN WriteCloseZEX(CLIPID ClipNo);
BOOLEAN SetZEXAplName(CLIPID ClipNo,UCHAR *Buf);
BOOLEAN AppendZEXDTMItemRec(CLIPID ClipNo,UCHAR DataID,UCHAR ConvID,
							ITEMNAME ItemName,
							UCHAR *Data,ULONG DataLen);
ZEXFP *ReadOpenZEX(CLIPID ClipNo,APLID AplName,CLIPNAME ClipName);
void ReadCloseZEX(ZEXFP *ZEXfp);
UCHAR *GetNextZEXRecord(UCHAR *RecPtr);
UCHAR *GetZEXDTMItemRec(ZEXFP *ZEXfp,UCHAR DataID,UCHAR ConvID,
						ITEMNAME ItemName,ULONG *DataLen);
BOOLEAN ZASSearchAplDataInFile(MESSAGE *Message,APLID DestAplName,
							   CATEGORYID CategoryID,UCHAR VolumeNo,
							   USHORT Number,ZAS_DATA_NO *Data);
BOOLEAN ZASReqSearchServ(MESSAGE *Message,APLID DestAplName,
						 UCHAR *SerString,USHORT Len,
						 USHORT SerParam,ZAS_SEARCH_INFO *ZASSerInfo);
BOOLEAN ZASReqCtgrMethodServ(MESSAGE *Message,APLID DestAplName,
							 USHORT CtgrParam,ZAS_DATA_NO *Data,
							 CATEGORYID Ctgr1,CATEGORYID Ctgr2);
BOOLEAN ZASCtgrMethodServ(MESSAGE *Message,FILEINFO *FInfoPtr);
BOOLEAN ZASGetPostIt(FILEINFO *FInfoPtr,CARDID CardID,
					 USHORT Number,UCHAR *Buf);
USHORT ZASCountPostIt(FILEINFO *FInfoPtr,CARDID CardID,APLID AplName);
BOOLEAN ZASDeletePostIt(FILEINFO *FInfoPtr,CARDID CardID,
						USHORT Number);
BOOLEAN ZASSearchAplPostIt(FILEINFO *FInfoPtr,CARDID CardID,
						   APLID AplName,USHORT *Number);
BOOLEAN IsAplPostItExist(FILEINFO *FInfoPtr,CARDID CardID,APLID AplName);
BOOLEAN ZASEncloseMail(MESSAGE *Message,UCHAR VolumeNo);
BOOLEAN ZASGetDataInfo(MESSAGE *Message,USHORT *Param,
					   ZAS_TARGET_DATA *ZASData,CLIPID *BoardNo);
BOOLEAN ZASChangeItem(MESSAGE *Message,ZAS_TARGET_DATA *ZASData,
					  ITEMNAME ItemName,void *Buffer,USHORT Length);
BOOLEAN ZASGetChangeItem(MESSAGE *Message,ZAS_TARGET_DATA *ZASData,
						 ITEMNAME ItemName,void *Buffer,USHORT *Length);
BOOLEAN ZASEncloseNewMail(MESSAGE *Message,UCHAR VolumeNo,USHORT ZasID);
BOOLEAN ZASReqSearchAndAddCtgrServ(MESSAGE *Message,APLID DestAplName,
								   UCHAR *SerString,USHORT Len,
								   ZAS_SEARCH_AND_ADD_CTGR_INFO *ZASSerInfo);
BOOLEAN ZASGetSearchAndAddCtgrInfo(MESSAGE *Message,
								   UCHAR *SerCond,USHORT *Len,
								   ZAS_SEARCH_AND_ADD_CTGR_INFO *ZASSerInfo);
void ZASCountAndResultAnswer(MESSAGE *Message,USHORT Count,UINT Result);
BOOLEAN ZASGetCountAndResultAnswer(MESSAGE *Message,
								   USHORT *Count,UINT *Result);

ZASERR ZASReqCameraService(MESSAGE *reqMessage,ZASIMGTYPE imgType);
PTR ZASGetCameraResult(MESSAGE *resultMsg,PTR imgBuf,DATALEN *len);
BOOLEAN ZASIsCategoryCount(MESSAGE *zasMessage,CATEGORYID *categoryID);

#define	GetZASService(msg)	((msg)->ZASCommonMsg.ZASInfo.ServiceID)
#define	GetZASVersion(msg)	((msg)->ZASCommonMsg.ZASInfo.Version)
#define	CleanupZEX(clip)	(CPClear(clip))
#define	GetZASSender(msg)	((msg)->ZASCommonMsg.ZASInfo.SenderAplName)

#define	IsSoundPostItExist(f,c)	IsAplPostItExist(f,c,'SDMM')
#define	IsPaintPostItExist(f,c)	IsAplPostItExist(f,c,'PANT')

/* |XgCbg\tvɂOUTǂׂ}N */
#define	IsZASAddPostItOut(msg)								\
((msg)->AppliOut.OutFactor.ZASCommonMsg.MessageID			\
 == AppliServExecReqID &&									\
 (msg)->AppliOut.OutFactor.ZASCommonMsg.ZASInfo.ServiceID	\
 == ZAS_ADD_POST_IT_ID)

/* ZAS_GROUP_DATA_IDp}N */
/* Ƃ̃T[rX͔ėp̃f[^i荞݁sT[rXƂĎ */
/* Ai荞݌̉ʂŏt@Cɖ߂{^At@C */
/* ̖{^Cg\ƂȂNCAg̗vɓ */
/* sȂKv邱Ƃ킩BlĔėp̃T[rXɂ */
/* ͂̎ԂȂBẴ}N`邱Ƃ */
/* ZAS_GROUP_DATA_ID͏t@ĈݎgpJX^T[rX */
/* łƌ߂ */
#define	ZASGetCTGRfromSerchCond(SerCond)	((CATEGORYID)SerCond[7])

#endif H2EQU

#endif
